package Browser;
use strict;
use Gtk2 ;

use constant { TRUE  => 1, FALSE => 0, };

my @MenuPlaying=		# sub parameters : @_= (toplevelwindow)
(	[_"Filter on playing Album", sub { $_[0]->SetFilter(1, ::SONG_ALBUM. 'e'.$::Songs[$::SongID][::SONG_ALBUM] ) if defined $::SongID; }],
	[_"Filter on playing Artist",sub { $_[0]->SetFilter(1, ::SONG_ARTIST.'~'.$::Songs[$::SongID][::SONG_ARTIST]) if defined $::SongID; }],
	[_"Filter on playing Song",  sub { $_[0]->SetFilter(1, ::SONG_TITLE. '~'.$::Songs[$::SongID][::SONG_TITLE] ) if defined $::SongID; }],
	[_"use the playing Filter",  sub { $_[0]->SetFilter(1, $::PlayFilter ); }, sub {$_[0]->{songlist}{mode} ne 'playlist'}], #FIXME 	if queue use queue, if $ListMode use list
);

sub makeFilterBox
{	my $box=Gtk2::HBox->new;
	my $FilterWdgt=FilterBox->new
	( sub	{	my $filt=FilterBox::posval2filter(@_);
			$box->get_toplevel->SetFilter(1,$filt);
		},
	  undef,
	  FilterBox::filter2posval(::SONG_TITLE.'s')
	);
	$FilterWdgt->addtomainmenu(_"edit ..." => sub
		{	my $w=$::LEventW=$box->get_toplevel;
			::EditFilter($w,$w->{Filter},undef,sub {$w->SetFilter(1,$_[0]) if defined $_[0]});
		});
	my $okbutton=::NewIconButton('gtk-apply',undef,sub {$FilterWdgt->activate},'none');
	$::Tooltips->set_tip($okbutton,_"apply filter");
	$box->pack_start($FilterWdgt, FALSE, FALSE, 0);
	$box->pack_start($okbutton, FALSE, FALSE, 0);
	return $box;
}

sub makeLockToggle
{	my $toggle=Gtk2::ToggleButton->new;
	$toggle->add(Gtk2::Image->new_from_stock('gmb-lock','menu'));
	#$toggle->set_active(1) if $self->{Filter0};
	$toggle->signal_connect( clicked =>sub
		{	my $window=$_[0]->get_toplevel;
			my $f=$window->{Filter0};
			my $empty=Filter::is_empty($f);
			if ($empty)	{ $window->SetFilter(0,$window->{Filter}); }
			else		{ $window->SetFilter(0,undef); }
		});
	$toggle->signal_connect (button_press_event => sub
		{	return 0 unless $_[1]->button==3;
			my $window=$_[0]->get_toplevel;
			$window->SetFilter(0,$window->{Filter});
			1;
		});
	$toggle->{OnChangedFilter}=sub
		{	my $self=$_[0];
			my $f=$self->get_toplevel->{Filter0};
			my $empty=Filter::is_empty($f);
			$self->set_active(!$empty);
			my $desc=($empty? _("No locked filter") : _("Locked on :\n").$f->explain);
			$::Tooltips->set_tip($self ,$desc);
		};
	return $toggle;
}

sub make_playing_menu
{	my $selfitem=$_[0];
	my $window=$selfitem->get_toplevel;
	my $menu=Gtk2::Menu->new;
	my $itemFollow=Gtk2::CheckMenuItem->new(_("Follow playing song"));
	my $tv=$window->{songlist};
	$itemFollow->set_active(1) if $tv->{TogFollow};
	$itemFollow->signal_connect( toggled => sub
	      { $tv->FollowSong if $tv->{TogFollow}^=1;}
	);
	$menu->append($itemFollow);
	my $menusub=sub { &{$_[1]}($window); };
	for my $aref (@MenuPlaying)
	{	next if $aref->[2] && !&{ $aref->[2] }($window);
		my $item = Gtk2::MenuItem->new($aref->[0]);
		$item->signal_connect( activate => $menusub,$aref->[1] );
		$menu->append($item);
	}
	return $menu;
}

sub make_sort_menu
{	my $selfitem=$_[0];
	my $window=$selfitem->get_toplevel;
	my $songlist=$selfitem->isa('SongList') ? $selfitem : $window->{songlist};
	my $menu=Gtk2::Menu->new;
	my $menusub=sub { $songlist->Sort($_[1]) };
	for my $name (sort keys %::SavedSorts)
	{   my $sort=$::SavedSorts{$name};
	    my $item = Gtk2::CheckMenuItem->new($name);
	    $item->set_draw_as_radio(1);
	    $item->set_active(1) if $songlist->{'sort'} eq $sort;
	    $item->signal_connect (activate => $menusub,$sort );
	    $menu->append($item);
	}
	my $itemEditSort=Gtk2::CheckMenuItem->new(_"Custom...");
	$itemEditSort->signal_connect (activate => sub
	{	$::LEventW=$window;
		my $sort=::EditSortOrder($songlist->{'sort'});
		$songlist->Sort($sort) if $sort;
	});
	$menu->append($itemEditSort);
	return $menu;
}

sub make_history_menuitem
{	my $self=Gtk2::MenuItem->new(_"Recent Filters");
	$self->{recent}=[ map Filter->new($_),split /\x00/,$::Options{RecentFilters} ];
	$self->{SaveOptions}=sub { $::Options{RecentFilters}=join "\x00",map $_->{string},@{ $self->{recent} }; return undef; };
	$self->{OnChangedFilter}=sub
	 {	my $self=shift;
		my $filter=$self->get_toplevel->{Filter};
		my $recent=$self->{recent};
		my $string=$filter->{string};
		my @recent=($filter,grep $_->{string} ne $string,@$recent);
		pop @recent if @recent>20;
		$self->{recent}=\@recent;
	 };
	return $self;
}

sub make_history_menu
{	my $selfitem=$_[0];
	my $window=$selfitem->get_toplevel;
	my $menu=Gtk2::Menu->new;
	my $mclicksub=sub   { $_[0]->{middle}=1 if $_[1]->button == 2; return 0; };
	my $menusub=sub
	 { my $f=($_[0]->{middle})? Filter->newadd(FALSE, $window->{Filter1},$_[1]) : $_[1];
	   $window->SetFilter(1,$f);
	 };
	for my $f (@{ $selfitem->{recent} })
	{	my $item = Gtk2::MenuItem->new( $f->explain );
		$item->signal_connect(activate => $menusub,$f);
		$item->signal_connect(button_release_event => $mclicksub,$f);
		$menu->append($item);
	}
	return $menu;
}

package LabelTotal;
use Gtk2;
use strict;
use warnings;

use base 'Gtk2::Button';

my %Modes=
(	list	 => [_"list",	\&Set_list],
	library	 => [_"library",\&Set_library],
	selected => [_"selected",\&Set_selected],
);

sub new
{	my ($class,$mode) = @_;
	my $self = bless Gtk2::Button->new, $class;
	$self->set_relief('none');
	$mode||='list';
	$self->add(Gtk2::Label->new);
	$self->signal_connect( destroy => \&Remove);
	$self->signal_connect( button_press_event => \&button_press_event_cb);
	$self->{watch}=::AddWatcher();
	$self->Set_mode($mode);
	return $self;
}

sub Set_mode
{	my ($self,$mode)=@_;
	$self->Remove;
	my $updatedo=&{ $Modes{$mode}[1] }($self);
	::IdleDo('9_Total'.$self,10,$updatedo,$self);
	$self->{SaveOptions}=$mode;
}

sub Remove
{	my $self=shift;
	delete $::ToDo{'9_Total'.$self};
	::RemoveWatcher($self->{watch});
	delete $self->{OnChangedFilter};
	delete $self->{OnChangedSelection};
}

sub button_press_event_cb
{	(my $self,$::LEvent)=@_;
	my $menu=Gtk2::Menu->new;
	for my $mode (sort {$Modes{$a}[0] cmp $Modes{$b}[0]} keys %Modes)
	{	my $item = Gtk2::CheckMenuItem->new( $Modes{$mode}[0] );
		$item->set_draw_as_radio(1);
		$item->set_active($mode eq $self->{SaveOptions});
		$item->signal_connect( activate => sub { $self->Set_mode($mode) } );
		$menu->append($item);
	 }
	$menu->show_all;
	$menu->popup(undef, undef, \&::menupos, undef, $::LEvent->button, $::LEvent->time);
}

sub Set_list
{	my $self=shift;
	$self->{OnChangedFilter}=
	$self->{queue}=sub { ::IdleDo('9_Total'.$self, 1000,\&Update_list,$self); };
	return \&Update_list;
}
sub Update_list
{	my $self=shift;
	my $window=$self->get_toplevel;
	my $array=$window->{songlist}{array};
	$self->child->set_text( _("Listed : ").::CalcListLength($array,'long') );
	$::Tooltips->set_tip( $self, $window->{Filter}->explain );
	::ChangeWatcher( $self->{watch}, $array, [::SONG_LENGTH,::SONG_SIZE], $self->{queue}, $self->{queue});
}

sub Set_selected
{	my $self=shift;
	$self->{OnChangedSelection}=
	$self->{queue}=sub { ::IdleDo('9_Total'.$self, 500,\&Update_selected,$self); };
	return \&Update_selected;
}
sub Update_selected
{	my $self=shift;
	my $songlist=$self->get_toplevel->{songlist};
	return unless $songlist;
	my $array=$songlist->{array};
	my $sel=$songlist->child->get_selection;
	my @list= map $array->[ $_->to_string ]  ,$sel->get_selected_rows;
	$self->child->set_text( _('Selected : ').::CalcListLength(\@list,'long') );
	$::Tooltips->set_tip( $self, ::__('%d song selected','%d songs selected',scalar@list) );
	::ChangeWatcher( $self->{watch}, \@list, [::SONG_LENGTH,::SONG_SIZE], $self->{queue} );
}

sub Set_library
{	my $self=shift;
	my $sub=
	$self->{queue}=sub { ::IdleDo('9_Total'.$self, 4000,\&Update_library,$self); };
	::ChangeWatcher( $self->{watch},undef, [::SONG_LENGTH,::SONG_SIZE],$sub,$sub,$sub);
	return \&Update_library;
}
sub Update_library
{	my $self=shift;
	$self->child->set_text( _('Library : ').::CalcListLength(\@::Library,'long') );
	$::Tooltips->set_tip( $self, ::__('%d song in the library','%d songs in the library',scalar@::Library) );
}

package EditList;
use Glib qw(TRUE FALSE);
use Gtk2;
use Gtk2::Gdk::Keysyms;
use strict;
use warnings;

my %ActionIndex=('' => 0, autofill=>1, 'wait'=>2, stop=>3, quit=>4);

use base 'Gtk2::VBox';

sub new
{	my ($class,$listmode,$opt1,$opt2)=@_;
	my $self = bless Gtk2::VBox->new, $class;
	$opt2=','.$opt2 if $opt2 && $opt2!~m/=/; #for old version
	$opt1="bpos=$1,hide=$2" if $opt1 and $opt1!~m/=/ and $opt1=~m/^([^,]*),?(.*)$/; #for old version
	my %opt1;
	if ($opt1)	{ $opt1{$1}=$2 while $opt1=~m/(\w+)=([^,]*)(?:,|$)/g; }
	$opt1{bpos}||='top';
	$opt1{hide}||='';
	$self->{qv}=
	my $qv=SongList->new(($listmode ? 'L' : 'Q'),$opt1,$opt2,\&ListChanged);
	$qv->{no_sort_indicator}=1;

	$qv->signal_connect (key_release_event => sub
		{	my ($qv,$event)=@_;
			if ($event->keyval == $Gtk2::Gdk::Keysyms{Delete})
			{	$self->{qv}->RemoveSelected;
				return 1;
			}
			return 0;
		});

	::Watch($self,($listmode ? 'SavedLists' : 'Queue'),\&Update);

	$self->AddToolbar($opt1{bpos},$listmode,$opt1{small});
	$self->add($qv);

	if ($opt1{hide}=~m/hide(shrink)?/)
	{	$self->{hide_if_empty}=$1? '2' : '1';
		$self->show_all;
		$self->set_no_show_all(1);
	}
	$self->Update unless $listmode;
	$self->{OnChangedSelection}=\&ChangedSelection;
	$self->{SaveOptions}=\&SaveOptions;
	return $self;
}

sub AddToolbar
{	my ($self,$pos,$listmode,$small)=@_;
	my $hbox=Gtk2::HBox->new;
	if	($pos eq 'top')		{ $self->pack_start($hbox,FALSE,FALSE,1); }
	elsif	($pos eq 'bottom')	{ $self->pack_end  ($hbox,FALSE,FALSE,1); }
	#elsif	($pos eq 'none')	{}
	else {return}
	$self->{toolbar}=1;
	#my $butadd=::NewIconButton('gtk-add','add'); ($small ? '' : 'remove')
	$self->{brm}=	::NewIconButton('gtk-remove',	($small ? '' : _"remove"),sub {$self->{qv}->RemoveSelected});
	$self->{bclear}=::NewIconButton('gtk-clear',	($small ? '' : _"clear"),sub {$self->Clear} );
	$self->{bup}=	::NewIconButton('gtk-go-up',		undef,		sub {$self->MoveOne(1)});
	$self->{bdown}=	::NewIconButton('gtk-go-down',		undef,		sub {$self->MoveOne(0)});
	$self->{btop}=	::NewIconButton('gtk-goto-top',		undef,		sub {$self->MoveMax(1)});
	$self->{bbot}=	::NewIconButton('gtk-goto-bottom',	undef,		sub {$self->MoveMax(0)});

	$::Tooltips->set_tip($self->{brm},_"Remove selected songs");
	$::Tooltips->set_tip($self->{bclear},_"Remove all songs");

	my @topack=qw/btop bup bdown bbot brm bclear/;
	unless ($listmode)
	{	$self->CreateQueueCombo;
		push @topack,qw/eventcombo spin/;
	}
	$hbox->pack_start($self->{$_},FALSE,FALSE,2) for @topack;
}

sub CreateQueueCombo
{	my $self=$_[0];

	my $action_store=Gtk2::ListStore->new(('Glib::String')x3);
	for my $action (sort {$ActionIndex{$a} <=> $ActionIndex{$b}} keys %ActionIndex)
	{	$action_store->set($action_store->append, 0,$::QActions{$action}[0], 1,$::QActions{$action}[1] ,2, $action );
	}

	$self->{queuecombo}=
	my $combo=Gtk2::ComboBox->new($action_store);

	my $renderer=Gtk2::CellRendererPixbuf->new;
	$combo->pack_start($renderer,FALSE);
	$combo->add_attribute($renderer, stock_id => 0);
	$renderer=Gtk2::CellRendererText->new;
	$combo->pack_start($renderer,FALSE);
	$combo->add_attribute($renderer, text => 1);

	$combo->signal_connect(changed => sub
		{	return if $self->{busy};
			my $iter=$_[0]->get_active_iter;
			my $action=$_[0]->get_model->get_value($iter,2);
			::EnqueueAction($action);
		});
	$self->{eventcombo}=Gtk2::EventBox->new;
	$self->{eventcombo}->add($combo);
	$self->{spin}=::NewPrefSpinButton('MaxAutoFill',sub
		{	return if $self->{busy};
			::HasChanged('Queue','action');
		},1,0,1,50,1,5);
	$self->{spin}->set_no_show_all(1);
}

sub SetList
{	my ($self,$name,$noupdate)=@_;
	$self->{listname}=$name;
	$self->Update($name) unless $noupdate;
	$self->get_toplevel->set_title( _("Editing list : ").$name );
}

sub Clear
{	my $self=shift;
	my $name=$self->{listname};
	if (defined $name) { $::SavedLists{$name}=[]; }
	else { @::Queue=(); }
	$self->HasChanged;
}

sub ListChanged
{	my $self=::find_ancestor($_[0],__PACKAGE__);
	$self->{busy}=1;
	my $array=$self->{qv}{array};
	my $name=$self->{listname};
	my $listref=defined $name ? $::SavedLists{$name} : \@::Queue;
	@$listref=@$array;
	$self->HasChanged;
	delete $self->{busy};
	$self->ChangedSelection;
}

sub HasChanged
{	my $self=shift;
	my $name=$self->{listname};
	if (defined $name) { ::HasChanged('SavedLists',$name); }
	else { ::HasChanged('Queue'); }
}

sub Update
{	my ($self,$type)=@_;
	return if $self->{busy};
	my $listref=\@::Queue;
	my $name=$self->{listname};
	if (defined $name)
	{	return unless defined $type && $name eq $type;
		$type=$_[2];
		if ($type && $type eq 'renamedto') { $self->SetList($_[3],1); return; }
		$listref=$::SavedLists{$name};
	}
	my $qv=$self->{qv};
	my $array=$qv->{array};
	$type||='';
	my $store=$qv->child->get_model;
	if ($type eq 'shift')
	{	$store->rowremove(0);
	}
	elsif ($type eq 'push')
	{	my $row=@$array;
		$store->rowinsert($row,@$listref[$row..$#$listref]);
	}
	elsif ($type eq 'action') {}
	else
	{	$qv->update_begin;
		@$array=@$listref;
		$qv->update_end;
	}
	$self->ChangedSelection;

	$self->UpdateQueueCombo if $self->{queuecombo};
	if ($self->{hide_if_empty})
	{	if	( @$listref &&  $self->{hidden})	{$self->Show}
		elsif	(!@$listref && !$self->{hidden})	{$self->Hide}
	}
}

sub UpdateQueueCombo
{	my $self=$_[0];
	$self->{busy}=1;
	my $action=$::QueueAction || '';
	$self->{queuecombo}->set_active( $ActionIndex{$action} );
	$::Tooltips->set_tip( $self->{eventcombo}, $::QActions{$action}[2] );
	my $m=($action eq 'autofill')? 'show' : 'hide';
	$self->{spin}->$m;
	$self->{spin}->set_value($::Options{MaxAutoFill});
	delete $self->{busy};
}


sub ChangedSelection
{	my $self=shift;
	my $qv=$self->{qv};
	my $array=$qv->{array};
	return if $self->{selbusy};
	my $treesel=$qv->child->get_selection;
	if ($self->{'select'})
	{ $self->{selbusy}=1;
	  $treesel->select_path( Gtk2::TreePath->new($_) ) for @{ delete $self->{'select'} };
	  delete $self->{selbusy};
	};
	return unless $self->{toolbar};
	my @rows=map $_->to_string, $treesel->get_selected_rows;
	if (@rows)
	{	$self->{brm}->set_sensitive(1);
		my $i=0;
		$i++ while $i<@rows && $rows[$i]==$i;
		$self->{$_}->set_sensitive($i!=@rows) for qw/btop bup/;
		$i=$#rows;
		$i-- while $i>-1 && $rows[$i]==$#$array-$#rows+$i;
		$self->{$_}->set_sensitive($i!=-1) for qw/bbot bdown/;
	}
	else
	{	$self->{$_}->set_sensitive(0) for qw/btop bbot brm bup bdown/;
	}
	$self->{bclear}->set_sensitive(scalar @$array);
}

sub MoveOne
{	my ($self,$up)=@_;
	my $name=$self->{listname};
	my $listref=defined $name ? $::SavedLists{$name} : \@::Queue;
	my $selection=$self->{qv}->child->get_selection;
	my @rows=map $_->to_string, $selection->get_selected_rows;
	my @newsel;
	while (@rows)
	{	my $cur=my $last=my $first=shift @rows;
		$cur=$last=shift @rows while @rows && $rows[0]==$cur+1;
		if ($up)
		{	if ($first==0) { push @newsel,$first..$last; next; }
			splice @$listref,$last,0,splice(@$listref,$first-1,1);
			push @newsel,($first-1)..($last-1);
		}
		else
		{	if ($last==$#$listref) { push @newsel,$first..$last; next; }
			splice @$listref,$first,0,splice(@$listref,$last+1,1);
			push @newsel,($first+1)..($last+1);
		}
	}
	$self->{'select'}=\@newsel;
	$self->HasChanged;
}
sub MoveMax
{	my ($self,$top)=@_;
	my $name=$self->{listname};
	my $listref=defined $name ? $::SavedLists{$name} : \@::Queue;
	my $selection=$self->{qv}->child->get_selection;
	my @rows=reverse map $_->to_string, $selection->get_selected_rows;
	return unless @rows;
	#@rows=sort {$b <=> $a } @rows;
	my @IDs;
	unshift @IDs,splice @$listref,$_,1 for @rows;
	if ($top)
	{	unshift @$listref,@IDs;
		$self->{'select'}=[0..(@rows-1)];
	}
	else #bottom
	{	push @$listref,@IDs;
		$self->{'select'}=[(@$listref-@rows)..$#$listref];
	}
	$self->HasChanged;
}

sub Show
{	my $self=$_[0];
	$self->{hidden}=undef;
	my $tl=$self->get_toplevel;
	$tl=undef if $tl==$self || $self->{hide_if_empty}!=2;
	$self->show; $tl->Vgrow if $tl;
}
sub Hide
{	my $self=$_[0]; return if $self->{hidden};
	$self->{hidden}=1;
	$self->hide;
	if ($self->parent && $self->{hide_if_empty}==2) { $self->get_toplevel->Vshrink; }
}

sub SaveOptions
{	my $self=shift;
	my $save=$self->{qv}->SaveOptions;
	$save=~s/(?:,|^)sort=([^,]*)(?:,|$)//;
	return $save;
}

package SongList;
use Glib qw(TRUE FALSE);
use Gtk2;
use Gtk2::Pango; #for PANGO_WEIGHT_BOLD, PANGO_WEIGHT_NORMAL
use strict;
use warnings;

use base 'Gtk2::ScrolledWindow';

use constant { SLCMENU => 0, SLCTITLE => 1, SLCVALUE => 2, SLCCLASS => 3, SLCATTRIB => 4, SLCTYPE => 5, SLCDEPEND => 6, SLCSORT => 7, SLCNONCOMP => 8};

our @SLC_Prop;
sub shouldbeINIT
{ no warnings;
  for my $n (grep $::TagProp[$_], 0..$#::TagProp)
  {	my $t=$::TagProp[$n][1];
	my $sub=($t eq 'd')? eval 'sub{my $v=$_[1][2]['.$n.']; $v ? scalar localtime $v : "'._('never').'"}'	:
		($t eq 'l')? eval 'sub{my $v=$_[1][2]['.$n.'];sprintf "%d:%02d",$v/60,$v%60}'	:
		($t eq 'f')? eval 'sub{join ", ",split(/\x00/,$_[1][2]['.$n.'])}'		:
			     eval 'sub{$_[1][2]['.$n.']}';
	$SLC_Prop[$n]=[ undef,$::TagProp[$n][0],$sub,undef,'text','Glib::String',[$n],$n ];
   };
   $SLC_Prop[::SLC_PR_BOLD]=[undef,undef,sub {$_[0]->{boldrow}==$_[1][1] ? PANGO_WEIGHT_BOLD : PANGO_WEIGHT_NORMAL}, undef,'weight','Glib::Uint'];
   $SLC_Prop[::SLC_TITLEAA]=[_('Title - Artist - Album'),_('Song'),sub {'<b>'.::PangoEsc($_[1][2][::SONG_TITLE])."</b>\n<small><i>".::PangoEsc($_[1][2][::SONG_ARTIST]).'</i> - '.::PangoEsc($_[1][2][::SONG_ALBUM]).'</small>'},undef, 'markup','Glib::String',[::SONG_TITLE,::SONG_ARTIST,::SONG_ALBUM],::SONG_TITLE,[::SLC_PR_BOLD]];
#  $SLC_Prop[::SLC_PLAYICO]=[_('Playing'),'',sub {$_[0]->{boldrow}==$_[1][1] ? 'gtk-media-play' : undef} ,'Gtk2::CellRendererPixbuf','stock-id','Glib::String',undef,undef,[::SLC_PR_BOLD]];
   $SLC_Prop[::SLC_PLAYICO]=[_('Playing & Queue'),'',sub { my $ID=$_[0]{array}[ $_[1][1] ]; $_[0]->{boldrow}==$_[1][1] ? 'gtk-media-play' : (@::Queue && grep $ID==$_, @::Queue)? 'gmb-queue' : undef; } ,'Gtk2::CellRendererPixbuf','stock-id','Glib::String',undef,undef,[::SLC_PR_BOLD]];
   $SLC_Prop[::SLC_ICOFLAGS]=[_('Icon Flags'),'',sub { $_[1][2][::SONG_FLAGS]; },'CellRendererIconList','iconlist','Glib::Scalar',[::SONG_FLAGS],::SONG_FLAGS,[::SLC_PR_BOLD]];
}

sub new
{	my ($class,$contextmenu,$opt1,$opt2,$OnChange) = @_;
	shouldbeINIT() unless @SLC_Prop;
	my %opt2;
	if ($opt2 && $opt2!~m/=/) { @opt2{qw/sort cols colsize/}=split ',',$opt2; $opt2=undef; } #for old version
	else
	{	#default values
		$opt2{'sort'}=join('_',::SONG_UPATH,::SONG_UFILE);
		$opt2{cols}=join('_',::SLC_TITLE,::SLC_ARTIST,::SLC_ALBUM,::SLC_DATE,::SLC_LENGTH,::SLC_TRACK,::SLC_UFILE,::SLC_LASTPLAY,::SLC_NBPLAY,::SLC_RATING);
		$opt2{colsize}='400_200_160_50_80_70_100_100_100_275_200_200_50_22_40_100_70_200_100_200_200_50_75_160_80_400_35';
	}
	if ($opt2)	{ $opt2{$1}=$2 while $opt2=~m/(\w+)=([^,]*)(?:,|$)/g; }

	my $array=[];
	#my $store=SongStore->new(array => $array);
	my $store=SongStore->new; $store->{array}=$array; #small work-around for bug in Glib<1.105 when used with perl 5.8.8
	my $self = bless Gtk2::ScrolledWindow->new(undef,undef), $class;
	$self->set_shadow_type('etched-in');
	$self->set_policy('automatic','automatic');
	my $tv=Gtk2::TreeView->new($store);
	$self->add($tv);
	$self->{$_}=$opt2{$_} for qw/sort colsize/;
	$self->{TogFollow}=1 if $opt2{follow};
	$self->{'sort'}=~tr/_/ /;
	$self->{array}=$array;
	$self->{store}=$store;
	$self->{IDsToAdd}=[];
	$self->{contextmenu}=$contextmenu;
	my %opt1;
	if ($opt1 && $opt1!~m/=/) { $opt1='mode='.$opt1; } #for version <0.9475
	if ($opt1)	{ $opt1{$1}=$2 while $opt1=~m/(\w+)=([^,]*)(?:,|$)/g; }
	$self->{mode}= $opt1{mode} || '';
	$self->{playrow}= defined $opt1{playrow} ? $opt1{playrow} : ::SLC_PR_BOLD;
	$self->{OnChange}=$OnChange;
	$self->{activate}=$opt1{activate} || 'play';

	::set_drag($tv,
		#[::DRAG_ID,sub { my $tv=$_[0]; $tv->parent->{array}[ ($self->get_cursor)[0]->to_string ]; }],
	source=>[::DRAG_ID,sub { my $tv=$_[0]; $tv->parent->GetSelectedIDs; }],
	dest =>	[::DRAG_ID,sub { my ($tv,$type,$dest,@IDs)=@_;
				$tv->signal_stop_emission_by_name('drag_data_received'); #override the default 'drag_data_received' handler on GtkTreeView
				 my $self=$tv->parent;
				 my (undef,$path,$pos)=@$dest;
				 my $row=$path? ($path->get_indices)[0] : scalar@{$self->{array}};
				 $row++ if $path && $pos && $pos eq 'after';
				 my $store=$tv->get_model;
				 if ($tv->{drag_is_source})
				 {	for my $oldrow (reverse map $_->to_string, $tv->get_selection->get_selected_rows)
					{	$store->rowremove($oldrow);
						$row-- if $row>$oldrow;
					}
				 }
				 my @newpaths;
				 $store->rowinsert($row,@IDs);
				 if ($tv->{drag_is_source})
				 {	$tv->get_selection->select_range( Gtk2::TreePath->new($row), Gtk2::TreePath->new($row+@IDs-1) );
				 }
				 &{ $self->{OnChange} }($self) if $self->{OnChange};
				}],
	motion => \&drag_motion_cb,
		);
	$tv->signal_connect(drag_data_delete => sub { $_[0]->signal_stop_emission_by_name('drag_data_delete'); }); #ignored

	$tv->set_rules_hint(TRUE);
	$tv->get_selection->set_mode('multiple');
	$tv->set_headers_clickable(TRUE);
	$tv->set_headers_visible(FALSE) if $opt1{headers} && $opt1{headers} eq 'off';
	$tv->set('fixed-height-mode' => TRUE);
	$self->{searchcol}=::SONG_TITLE;
	$tv->set_search_column( $self->{searchcol} );
	$tv->set_enable_search(TRUE);
#	$tv->set_search_equal_func (sub
#		{   my($store,$col,$pat,$iter)=@_;
#		    my $s=$store->get($iter,$col);
#		    return $s!~m/^$pat/i;
#		});
	$tv->signal_connect (key_release_event => sub	#empty for now
		{	warn "@_\n";
		}) if $::debug;
	MultiTreeView::init($tv,__PACKAGE__);
	$tv->signal_connect(cursor_changed	=> \&cursor_changed_cb);
	$tv->signal_connect(row_activated	=> \&row_activated_cb);
	$tv->get_selection->signal_connect(changed => \&sel_changed_cb);

	$self->AddColumn($_) for split '_',$opt2{cols};

	$self->{watcher}||=::AddWatcher();
	$self->signal_connect(destroy => \&removewatchers);
	::Watch($self,'SongID',\&UpdateSelID);
	$self->{OnChangedFilter}=\&SetFilter;
	$self->{SaveOptions}=\&SaveOptions;
	if ($self->{mode} eq 'playlist')
	{	$self->{OnChange}=\&PlaylistUpdate;
		::Watch($self,'Filter',	\&SetPlaylistFilter);
		::Watch($self,'Sort',	\&SetPlaylistSort);
		$self->{'sort'}=($::Options{Sort}=~m/[^r]/)? $::Options{AltSort} : $::Options{Sort};
	}
	elsif ($self->{mode} eq 'noall') { $tv->show_all; $self->set_no_show_all(1); }
	return $self;
}

sub removewatchers
{	my $self=shift;
	::RemoveWatcher( $self->{watcher} );
}

sub SaveOptions
{	my $self=shift;
	my $tv=$self->child;
	my $sort=$self->{'sort'};
	$sort=~tr/ /_/;
	#save displayed cols
	my $cols=join '_',(map $_->{colnb},$tv->get_columns);
	#save their width
	my @size=split '_',$self->{colsize};
	$size[ $_->{colnb} ]=$_->get_width for $tv->get_columns;
	my $colsize=join '_',@size;
	my $follow=$self->{TogFollow}? ",follow=1" : '';
	return "sort=$sort,cols=$cols,colsize=$colsize".$follow;
}

sub AddColumn
{	my ($self,$n,$pos)=@_;
	my $attrib=$SLC_Prop[$n][SLCATTRIB];
	my $renderer=	( $SLC_Prop[$n][SLCCLASS] || 'Gtk2::CellRendererText' )->new;
	my $playrow=$self->{playrow};
	my @attributes=($SLC_Prop[$n][SLCTITLE],$renderer,$attrib,$n);
	if (my $ref=$SLC_Prop[$n][SLCNONCOMP]) { $playrow=0 if (grep $_==$playrow,@$ref); }
	push @attributes,$SLC_Prop[$playrow][SLCATTRIB],$playrow if $playrow;
	my $column = Gtk2::TreeViewColumn->new_with_attributes(@attributes);

	#$renderer->set_fixed_height_from_font(1);
	$column->{colnb}=$n;
	$column->set_sizing('fixed');
	$column->set_resizable(TRUE);
	$column->set_fixed_width( (split '_',$self->{colsize})[$n] || 100 );
	$column->set_clickable(TRUE);
	$column->set_reorderable(TRUE);

	$column->signal_connect(clicked => sub
		{	#warn "column : @_\n";
			my $s=$_[1];
			$s='-'.$s if $self->{'sort'} eq $s;
			$self->Sort($s);
		},$SLC_Prop[$n][SLCSORT]) if defined $SLC_Prop[$n][SLCSORT];
	my $tv=$self->child;
	if (defined $pos)	{ $tv->insert_column($column, $pos); }
	else			{ $tv->append_column($column); }
	#################################### connect col selection menu to right-click on column
	my $label=Gtk2::Label->new($SLC_Prop[$n][SLCTITLE]);
	$column->set_widget($label);
	$label->show;
	my $button_press_sub=sub
		{ $::LEvent=$_[1];
		  return 0 unless $::LEvent->button == 3;
		  $self->SelectColumns($_[2]);	# $_[2]=$n
		  1;
		};
	my $button=$label->get_ancestor('Gtk2::Button'); #column button
	$button->signal_connect(button_press_event => $button_press_sub,$n) if $button;
	return $column;
}

sub UpdateSortIndicator
{	my $self=$_[0];
	my $tv=$self->child;
	return if $self->{no_sort_indicator};
	my $s=$self->{'sort'};
	my $col=$self->{SortedColumn};
	$col->set_sort_indicator(FALSE) if $col;
	if ($s=~m/^(-)?([0-9]+)$/)
	{	my $order=($1)? 'descending' : 'ascending';
		($col)=grep $_->{colnb}==$2,$tv->get_columns;
		if ($col)
		{ $col->set_sort_indicator(TRUE);
		  $col->set_sort_order($order);
		  $self->{SortedColumn}=$col;
		}
	}
}

sub SelectColumns
{	my ($self,$pos)=@_;
	my $menu = Gtk2::Menu->new;

	{	my $item=Gtk2::MenuItem->new(_"_Sort by");
		$menu->append($item);
		$item->set_submenu( Browser::make_sort_menu($self) );
	}

	my $menuinsert=Gtk2::Menu->new;
	my $iteminsert=Gtk2::MenuItem->new(_"_Insert column");
	$iteminsert->set_submenu($menuinsert);
	my $tv=$self->child;
	my %present;
	$present{$_}=undef for map($_->{colnb}, $tv->get_columns);
	for my $col (0..$#SLC_Prop)
	{ next unless my $name= $SLC_Prop[$col][SLCMENU] || $SLC_Prop[$col][SLCTITLE];
	  next if exists $present{$col};
	  my $item=Gtk2::MenuItem->new( $name );
	  $item->signal_connect (activate => \&ToggleColumn,[$self,$col,$pos]);
	  $menuinsert->append($item);
	}

	$menu->append($iteminsert);
	my $itemrm=Gtk2::MenuItem->new(_('_Remove this column').' ('. ($SLC_Prop[$pos][SLCMENU] || $SLC_Prop[$pos][SLCTITLE]).')' );
	$itemrm->signal_connect (activate => \&ToggleColumn,[$self,$pos,$pos]);
	$menu->append($itemrm);

	$menu->show_all;
	$menu->popup(undef,undef,undef,undef,$::LEvent->button,$::LEvent->time);
}

sub ToggleColumn
{	my ($self,$colnb,$colpos)=@{ $_[1] };
	my $tv=$self->child;
	my $position;
	my $n=0;
	for my $column ($tv->get_columns)
	{	if ($column->{colnb} == $colnb)
		{	#FIXME save column width
			$tv->remove_column($column);
			undef $position;
			last;
		}
		$n++;
		$position=$n if $column->{colnb} == $colpos;
	}
	$self->AddColumn($colnb,$position) if defined $position;
	$self->AddColumn(::SONG_TITLE) unless $tv->get_columns; #if removed the last column
	$self->{cols_to_watch}=undef; #to force update list of columns to watch
	$self->UpdateWatcher;
}

sub UpdateWatcher
{	my $self=$_[0];
	my $tv=$self->child;
	my $cols=$self->{cols_to_watch}||=[ map @{ $SLC_Prop[ $_->{colnb} ][SLCDEPEND] || [] }, $tv->get_columns ];
	::ChangeWatcher
	( $self->{watcher},
		$self->{array},
		$cols,
		sub{$self->UpdateID(@_)},
		sub{$self->RemoveID(@_)},
		 #keep list up to date with the filter in playlist mode
		($self->{mode} eq 'playlist' ? sub {$self->QueueIDsToAdd(@_)} : undef ),
		($self->{mode} eq 'playlist' && !$::ListMode ? $self->{filter} : undef )
	);
}

sub PopupContextMenu
{	my ($self,$tv,$event)=@_;
	my @IDs=$self->GetSelectedIDs;
	$::LEvent=$event;
	$::LEventW=$self->get_toplevel;
	my %args=(self => $self, mode => $self->{contextmenu}, IDs => \@IDs, listIDs => $self->{array});
	::PopupContextMenu(\@::SongCMenu,\%args ) if @{$self->{array}};
}

sub GetSelectedIDs
{	my $self=$_[0];
	my @rows=$self->child->get_selection->get_selected_rows;
	my @IDs=map $self->{array}[$_->to_string], @rows;
	return @IDs;
}

sub PlaySelected
{	my $self=$_[0];
	my @IDs=$self->GetSelectedIDs;
	::Select(undef,undef,'first','play', \@IDs ) if @IDs;
}
sub EnqueueSelected
{	my $self=$_[0];
	my @IDs=$self->GetSelectedIDs;
	::Enqueue(@IDs) if @IDs;
}

sub drag_motion_cb
{	my ($tv,$context,$x,$y,$time)=@_;# warn "drag_motion_cb @_";
	::drag_checkscrolling($tv,$context,$y);
	my ($path,$pos)=$tv->get_dest_row_at_pos($x,$y);	#FIXME sometimes : "Gtk-CRITICAL **: gtk_tree_view_get_dest_row_at_pos: assertion `drag_x >= 0' failed"
	if ($path)
	{	$pos= ($pos=~m/after$/)? 'after' : 'before';
	}
	else	#cursor is in an empty (no rows) zone #FIXME also happens when above or below treeview
	{	my $n=$tv->get_model->iter_n_children;
		$path=Gtk2::TreePath->new_from_indices($n-1) if $n; #at the end
		$pos='after';
	}
	$context->{dest}=[$tv,$path,$pos];
	$tv->set_drag_dest_row($path,$pos);
	$context->status(($tv->{drag_is_source} ? 'move' : 'copy'),$time);
	return 1;
}

sub enqueue_current
{	my $self=shift;
	my $tv=$self->child;
	my $row=($tv->get_cursor)[0]->to_string;
	my $ID=$self->{array}[$row];
	::Enqueue($ID);
}

sub sel_changed_cb
{	my $treesel=$_[0];
	$treesel->get_tree_view->get_toplevel->ChangedSelection;
}
sub cursor_changed_cb
{	my $tv=$_[0];
	my $row=($tv->get_cursor)[0]->to_string;
	return unless defined $row;
	my $self=$tv->parent;
	my $ID=$self->{array}[$row];
	$tv->get_toplevel->ChangeSelID($ID);
}

sub row_activated_cb
{	my ($tv,$path,$column)=@_;
	my $self=$tv->parent;
	my $ID=$self->{array}[ $path->to_string ];
	if ($self->{activate} eq 'play')	{ ::Select(undef,undef,$ID,'play'); }
	elsif ($self->{activate} eq 'queue')	{ ::Enqueue($ID); }
}

sub PlaylistUpdate
{	my $self=$_[0];
	return unless $self->{mode} eq 'playlist';
	return if $self->{from_playlist};
	$self->{from_playlist}=1;
	::Select(undef,undef,'trykeep',undef, $self->{array} );
	$self->{from_playlist}=undef;
}

sub SetFilter
{	my $self=$_[0];
	my $filter=$_[1] || $self->get_toplevel->{Filter};
	my $list;
	if ($self->{mode} eq 'noall')
	{	if ($filter->is_empty)	{ $self->hide; $self->get_toplevel->Vshrink;return}
		else			{ $self->show; $self->get_toplevel->Vgrow}
	}
	elsif ($self->{mode} eq 'playlist')
	{	if ($self->{from_playlist})	{ $filter=$::PlayFilter; $list=\@::ListPlay; }
		else				{ ::Select( $self->get_toplevel->{Filter} ); return; }
	}
	$self->{filter}=$filter;
	$self->{IDsToAdd}=[];
	$self->update_begin;
	@{ $self->{array} }= defined $list ? @$list : @{ $filter->filter };
	::SortList( $self->{array}, $self->{'sort'} ) unless $list;
	$self->update_end;
}

sub update_begin
{	my $tv=$_[0]->child;
	$tv->set_model(undef);
}
sub update_end
{	my $self=$_[0];
	my $tv=$self->child;
	$tv->set_model($self->{store});
	$tv->set_search_column($self->{searchcol}); #setting model to undef reset search_column => re-set it
#	$tv->scroll_to_cell(Gtk2::TreePath->new(0)) if @{$self->{array}}>0;
# test about a "Modification of a read-only value attempted" error
	my $row=0;
	my $tp=Gtk2::TreePath->new($row);
	$tv->scroll_to_cell($tp) if @{$self->{array}}>0;
#
	$self->UpdateSelID;
	$self->UpdateWatcher;
}

sub UpdateSelID
{	my $self=$_[0];
	$self->{store}->updateboldrow;
	$self->FollowSong if $self->{TogFollow};
}

sub FollowSong
{	my $self=$_[0];
	my $tv=$self->child;
	#$tv->get_selection->unselect_all;
	my $rowplaying=$tv->get_model->{boldrow};
	if ($rowplaying>-1)
	{	my $path=Gtk2::TreePath->new($rowplaying);
		$tv->set_cursor($path);
		my $visible;
		if ($tv->window)	#check if row is visible -> no need to scroll_to_cell
		{	#maybe should use gtk_tree_view_get_visible_range (requires gtk 2.8)
			my $first=$tv->get_path_at_pos(0,0);
			my $last=$tv->get_path_at_pos(0,($tv->window->get_geometry)[3]);
			return unless $first && $last;
			$first=$first->to_string+2;
			$last=$last->to_string-2;
			$visible=1 if $rowplaying<$first || $rowplaying>$last;
		}
		$tv->scroll_to_cell($path,undef,TRUE,.5,.5) unless $visible;
	}
	elsif (defined $::SongID)
	{ $tv->get_toplevel->ChangeSelID($::SongID); }
}

sub Sort
{	my ($self,$sort)=@_;
	if ($self->{mode} eq 'playlist')
	{	::Select_sort( $sort ) unless $self->{from_playlist};
	}
	warn "Reordering...\n" if $::debug;
	my $tv=$self->child;
	my $treesel=$tv->get_selection;
	$self->{'sort'}=$sort;
	my $array=$self->{array};
	my @selected=map $array->[ $_->to_string ], $treesel->get_selected_rows;
	#@selected now contains selected IDs
	$treesel->unselect_all;
	$self->update_begin;
	if ($self->{IDsToAdd}) {push @$array,@{$self->{IDsToAdd}}; $self->{IDsToAdd}=[];}
	::SortList($array,$sort);
	$self->update_end;
	my @order;
	#restore selection
	$order[ $$array[$_] ]=$_ for 0..$#$array;
	#$order[$ID] contains the new row number of $ID
	$treesel->select_path( Gtk2::TreePath->new($order[$_]) ) for @selected;
	warn "Reordering...done\n" if $::debug;
	$self->UpdateSortIndicator;
	&{ $self->{OnChange} }($self) if $self->{OnChange};
}

sub Empty
{	my $self=shift;
	$self->update_begin;
	@{ $self->{array} }=();
	&{ $self->{OnChange} }($self) if $self->{OnChange};
}

sub RemoveSelected
{	my $self=shift;
	my $tv=$self->child;
	my $store=$tv->get_model;
	my @rows=sort {$b <=> $a} map $_->to_string, $tv->get_selection->get_selected_rows;
	$tv->get_selection->unselect_all;
	$store->rowremove($_) for @rows;
	&{ $self->{OnChange} }($self) if $self->{OnChange};
}

sub RemoveID
{	my $self=$_[0];
	my $store=$self->child->get_model;
	my $array=$self->{array};
	my %toremove;
	$toremove{$_}=undef for @_;
	warn "remove ID @_\n" if $::debug;
	my $row=@$array;
	while ($row-->0)
	{ my $ID=$$array[$row];
	  next unless exists $toremove{$ID};
	  $store->rowremove($row);
	  #delete $toremove{$ID};
	  #last unless (keys %toremove);
	}
	my $toadd=$self->{IDsToAdd};
	if (@$toadd && keys %toremove)
	{ @$toadd=grep !exists $toremove{$_},@$toadd; }
}
sub UpdateID
{	my $self=$_[0];
	my $array=$self->{array};
	my $store=$self->child->get_model;
	my %updated;
	warn "update ID @_\n" if $::debug;
	$updated{$_}=undef for @_;
	my $row=@$array;
	while ($row-->0)
	{ my $ID=$$array[$row];
	  next unless exists $updated{$ID};
	  $store->rowchanged($row);
	  #delete $updated{$ID};
	  #last unless (keys %updated);
	}
}

sub AddQueuedIDs
{	my $self=$_[0];
	return unless @{$self->{IDsToAdd}};
	$self->{from_playlist}=1;
	$self->Sort($self->{'sort'});
	$self->{from_playlist}=undef;
}

sub QueueIDsToAdd	#FIXME IDs are not re-checked by watcher until they are actually added, could be no longer matching the filter
{	my $self=shift;
	push @{$self->{IDsToAdd}},@_;
	::IdleDo('7_SongListAdd_'.$self,1500,\&AddQueuedIDs,$self)
}

# methods for playlist mode
sub SetPlaylistSort
{	my $self=$_[0];
	$self->{from_playlist}=1;
	$self->Sort($::Options{Sort}) if $::Options{Sort}=~m/^[^r]/;
	$self->{from_playlist}=undef;
}
sub SetPlaylistFilter
{	my $self=$_[0];
	$self->{from_playlist}=1;
	$self->SetFilter;
	$self->{from_playlist}=undef;
}

################################################################################
package SongStore;
use Glib qw(TRUE FALSE);
use Gtk2;
#use Gtk2::Pango; #for PANGO_WEIGHT_BOLD, PANGO_WEIGHT_NORMAL
use strict;
no warnings;

my (@Value,@Type);

use Glib::Object::Subclass
	Glib::Object::,
	interfaces => [Gtk2::TreeModel::],
	properties => [ Glib::ParamSpec->scalar
			('array',		 #name
			 'array',		 #nickname
			 'arrayref',		 #blurb
			 [qw/readable writable/] #flags
		 	)
		      ],
	;

sub INIT_INSTANCE {
	my $self = shift;

	unless (@Value)	#should be in a INIT block, but the INIT block isn't called
	{	for (0..$#SongList::SLC_Prop)
		{	$Value[$_]=$SongList::SLC_Prop[$_][SongList::SLCVALUE];
			$Type[$_]= $SongList::SLC_Prop[$_][SongList::SLCTYPE];
		}
	}

	# Random int to check whether an iter belongs to our model
	$self->{stamp} = sprintf '%d', rand (1<<31);
	$self->{boldrow}=-1;
}
sub FINALIZE_INSTANCE
{	#my $self = shift;
	# free all records and free all memory used by the list
}
sub GET_FLAGS { [qw/list-only iters-persist/] }
sub GET_N_COLUMNS { ::SLCLAST }
#sub GET_COLUMN_TYPE {($_[1]==BOLDPLAY)? 'Glib::Uint' :'Glib::String'}
sub GET_COLUMN_TYPE { $Type[ $_[1] ]; }
sub GET_ITER
{	my ($self, $path) = @_; #warn "GET_ITER\n";
	die "no path" unless $path;

	# we do not allow children
	# depth 1 = top level; a list only has top level nodes and no children
#	my $depth   = $path->get_depth;
#	die "depth != 1" unless $depth == 1;

#	my @indices = $path->get_indices;
#	my $n = $indices[0]; # the n-th top level row
#	my $n=($path->get_indices)[0];
	my $n=$path->get_indices;	#return only one value because it's a list
	return undef if $n >= @{$self->{array}} || $n < 0;

	#my $ID = $self->{array}[$n];
	#die "no ID" unless defined $ID;
	#return iter :
	#return [ $self->{stamp}, $n, undef, undef ];
	return [ $self->{stamp}, $n, $::Songs[ $self->{array}[$n] ] , undef ];
}

sub GET_PATH
{	my ($self, $iter) = @_; #warn "GET_PATH\n";
	die "no iter" unless $iter;

	my $path = Gtk2::TreePath->new;
	$path->append_index ($iter->[1]);
	return $path;
}

sub GET_VALUE
{	goto &{ $Value[$_[2]] };
#	my ($self, $iter, $column) = ($_[0],$_[1],$_[2]); #warn "GET_VALUE\n";
#	#die "bad iter" unless $iter;
#	return  ( ($self->{boldrow} == $iter->[1])
#		  ? PANGO_WEIGHT_BOLD : PANGO_WEIGHT_NORMAL
#		) if $column==::SONGLAST+1;
#	#return undef if $column > ::SONGLAST;
#	my $val=$iter->[2][$column];
#
#	my $t=$Type[$column];
#	#use POSIX qw(strftime); $now_string = strftime '%d-%m-%y %H:%M', localtime;
#	return  (!$t	  )? $val					:
#		($t eq 'd')? ($val ? scalar localtime $val : 'never')	:
#		($t eq 'l')? (sprintf '%d:%02d',$val/60,$val%60)	:
#		($t eq 'f')? (join ', ',split(/\x00/,$val))		:
#			     $val;
#	#return $ref->[$column];
}

sub ITER_NEXT
{	my $self=$_[0];
#	return undef unless $_[1];
	my $n=$_[1]->[1]; #$iter->[1]
	#my ($self, $iter) = @_; #warn "GET_NEXT\n";
	return undef unless ++$n < @{$self->{array}};
	#return [ $self->{stamp}, $n, undef, undef ];
	return [ $self->{stamp}, $n, $::Songs[ $self->{array}[$n] ], undef ];
}

sub ITER_CHILDREN
{	my ($self, $parent) = @_; #warn "GET_CHILDREN\n";
	# this is a list, nodes have no children
	return undef if $parent;

	# parent == NULL is a special case; we need to return the first top-level row
 	# No rows => no first row
	return undef unless @{ $self->{array} };

	# Set iter to first item in list
	return [ $self->{stamp}, 0, $::Songs[ $self->{array}[0] ],undef ];
	#return [ $self->{stamp}, 0, undef, undef ];
}
sub ITER_HAS_CHILD { FALSE }
sub ITER_N_CHILDREN
{	my ($self, $iter) = @_; #warn "ITER_N_CHILDREN\n";
	# special case: if iter == NULL, return number of top-level rows
	return ( $iter? 0 : scalar @{$self->{array}} );
}
sub ITER_NTH_CHILD {
	my ($self, $parent, $n) = @_; #warn "ITER_NTH_CHILD\n";
	# a list has only top-level rows
	return undef if $parent;
	# special case: if parent == NULL, set iter to n-th top-level row
	return undef if $n >= @{$self->{array}};

	#my $ID = $self->{array}[$n];
	#die "no record" unless defined $ID;
	#return [ $self->{stamp}, $n, undef, undef ];
	return [ $self->{stamp}, $n,  $::Songs[ $self->{array}[$n] ] , undef ];
}
sub ITER_PARENT { FALSE }

sub rowremove
{	my ($self,$row)=($_[0],$_[1]);
	splice @{$self->{array}}, $row ,1;
	if    ($self->{boldrow}>$row)  { $self->{boldrow}-- }
	elsif ($self->{boldrow}==$row) { $self->{boldrow}=-1}
	$self->row_deleted( Gtk2::TreePath->new($row) );
}
sub rowinsert
{	my ($self,$row,@IDs)=@_;
	splice @{ $self->{array} }, $row, 0, @IDs;
	$self->{boldrow}+=@IDs if $self->{boldrow}>=$row;
	for (@IDs)
	{	$self->{boldrow}=$row if $self->{boldrow}==-1 && defined $::SongID && $_==$::SongID;
		$self->row_inserted( Gtk2::TreePath->new($row), $self->get_iter_from_string($row) );
		$row++;
	}
}
sub rowchanged
{	my ($self,$row)=($_[0],$_[1]);
	my $iter=$self->get_iter_from_string($row);
	return unless $iter;
	$self->row_changed( $self->get_path($iter), $iter);
}

sub updateboldrow
{	my $self=$_[0];
	my $array=$self->{array};
	if ($self->{boldrow}!=-1)
	{	my $row=$self->{boldrow};
		$self->{boldrow}=-1;
		$self->rowchanged($row);
	}
	if (defined $::SongID)
	{ for my $row (0..$#$array)		#search row of currently playing
	  { if ($::SongID==$$array[$row])	#add bold to currently playing
	    {	$self->{boldrow}=$row;
		$self->rowchanged($row);
		last;
	    }
	  }
	}
}

package MultiTreeView;
#for common functions needed to support correct multi-rows drag and drop in treeviews

sub init
{	my ($tv,$selfpkg)=@_;
	$tv->{selfpkg}=$selfpkg;
	$tv->{drag_begin_cb}=\&drag_begin_cb;
	$tv->signal_connect(button_press_event=> \&button_press_cb);
	$tv->signal_connect(button_release_event=> \&button_release_cb);
}

sub drag_begin_cb
{	my ($tv,$context)=@_;# warn "drag_begin @_";
	$tv->{pressed}=undef;
}

sub button_press_cb
{	my ($tv,$event)=@_;
	my $self=::find_ancestor($tv, $tv->{selfpkg} );
	my $but=$event->button;
	my $sel=$tv->get_selection;
	if ($but==2 && $event->type eq '2button-press') { $self->enqueue_current; return 1; }
	if ($but==1) # do not clear multi-row selection if button press on a selected row (to allow dragging selected rows)
	{{	 last if $event->get_state * ['shift-mask', 'control-mask']; #don't interfere with default if contol or shift is pressed
		 last unless $sel->count_selected_rows  > 1;
		 my $path=$tv->get_path_at_pos($event->get_coords);
		 last unless $path && $sel->path_is_selected($path);
		 $tv->{pressed}=1;
		 return 1;
	}}
	if ($but == 3)
	{	$self->PopupContextMenu($tv,$event);
		return 1;
	}
	return 0; #let the event propagate
}

sub button_release_cb #clear selection and select current row only if the press event was on a selected row and there was no dragging
{	my ($tv,$event)=@_;
	return 0 unless $event->button==1 && $tv->{pressed};
	$tv->{pressed}=undef;
	my $path=$tv->get_path_at_pos($event->get_coords);
	return 0 unless $path;
	my $sel=$tv->get_selection;
	$sel->unselect_all;
	$sel->select_path($path);
	return 1;
}

package FilterPane;
use Gtk2;
use strict;
use warnings;
use base 'Gtk2::VBox';

use constant { TRUE  => 1, FALSE => 0, };

my %pages=
(	filter	=> [SavedTree		=> 'F',			0b001, _('Filter')],
	list	=> [SavedTree		=> 'L',			0b001, _('List')],
	savedtree=>[SavedTree		=> 'FL',		0b001, _('Saved')],
	artist	=> [FilterList		=> ::SONG_ARTIST,	0b111],
	album	=> [FilterList		=> ::SONG_ALBUM,	0b110],
	genre	=> [FilterList		=> ::SONG_GENRE,	0b011],
	date	=> [FilterList		=> ::SONG_DATE,		0b010],
	flag	=> [FilterList		=> ::SONG_FLAGS,	0b011],
	folder	=> [FolderList		=> ::SONG_UPATH,	0b010],
);

my @MenuAAFPaneOptions=
(	{ label => _"show pictures",	code => sub { my $self=$_[0]{self}; $self->{valid}=0; $self->{picsize}= $self->{picsize} ? 0 : 32; $self->Fill; },
	  check => sub {$_[0]{self}->{picsize}} },
	{ label => _"show info",	code => sub { my $self=$_[0]{self}; $self->{valid}=0; $self->{showinfo}^=1; $self->Fill; },
	  check => sub {$_[0]{self}->{showinfo}} },
	{ label => _"sort by year",	code => sub { my $self=$_[0]{self}; $self->{valid}=0; $self->{'sort'}= $_[0]{self}->{'sort'} eq 'alpha' ? 'year' : 'alpha'; $self->Fill; },
	  check => sub {$_[0]{self}->{'sort'} ne 'alpha'} },
);

sub new
{   my ($class,$opt1,$opt2)=@_;
    my $self = bless Gtk2::VBox->new(FALSE, 6), $class;
    $self->{SaveOptions}=\&SaveOptions;
    my ($nb,@pids);
    my (%opt1,%opt2);
    if (defined $opt1)
    {	if ($opt1!~m/=/) { ($nb,$opt1{hide},@pids)=split ',',$opt1; $nb++; }
    	else
	{	$opt1{$1}=$2 while $opt1=~m/(\w+)=([^,]*)(?:,|$)/g;
		$nb=$opt1{nb};
		@pids=split /\|/, $opt1{pages} if $opt1{pages};
	}
    }
    $nb=1 unless defined $nb;
    $self->{nb}=$nb;
    @pids=qw/savedtree artist album genre date flag folder/ unless @pids;
    if ($opt2 && $opt2!~m/=/) { (my$page,$opt2{min})=split ',',$opt2; $opt2=undef; $opt2{page}=$pids[$page] if defined $page && $page<@pids } #for old version
    if ($opt2)	{ $opt2{$1}=$2 while $opt2=~m/(\w+)=([^,]*)(?:,|$)/g; }
    $self->{min}=$opt2{min}||1;

    my $spin=Gtk2::SpinButton->new( Gtk2::Adjustment->new($self->{min}, 1, 9999, 1, 10, 1) ,10,0  );
    $spin->signal_connect( value_changed => sub { $self->update($_[0]->get_value); } );
    my $ResetB=::NewIconButton('gtk-clear',undef,sub { $_[0]->get_toplevel->SetFilter($nb,undef); });
    $ResetB->set_sensitive(0);
    my $InterB=Gtk2::ToggleButton->new;
    my $InterBL=Gtk2::Label->new;
    $InterBL->set_markup('<b>&amp;</b>');  #bold '&'
    $InterB->add($InterBL);
    my $InvertB=Gtk2::ToggleButton->new;
    my $optB=Gtk2::Button->new;
    $InvertB->add(Gtk2::Image->new_from_stock('gmb-invert','menu'));
    $optB->add(Gtk2::Image->new_from_stock('gtk-preferences','menu'));
    $InvertB->signal_connect( toggled => sub {$self->{invert}=$_[0]->get_active;} );
    $InterB->signal_connect(  toggled => sub {$self->{inter} =$_[0]->get_active;} );
    $optB->signal_connect( button_press_event => \&PopupAAOpt );
    $optB->set_relief('none');
    my $hbox = Gtk2::HBox->new (FALSE, 6);
    $hbox->pack_start($_, FALSE, FALSE, 0) for $spin, $ResetB, $InvertB, $InterB, $optB;
    $::Tooltips->set_tip($ResetB, ($nb==1? _"reset primary filter" : $nb==2? _"reset secondary filter" : ::__x(_"reset filter {nb}",nb =>$nb)) );
    $::Tooltips->set_tip($InterB,_"toggle Intersection mode");
    $::Tooltips->set_tip($InvertB,_"toggle Invert mode");
    $::Tooltips->set_tip($spin,_"minimum number of songs"); #FIXME
    $::Tooltips->set_tip($optB,_"options");

    my $notebook = Gtk2::Notebook->new;
    $notebook->set_scrollable(TRUE);
    $notebook->popup_enable;
    $notebook->set_show_tabs(FALSE) if @pids==1;

    my $setpage=0;
    my @fieldlist;
    for my $pid (@pids)
    {	next unless $pages{$pid};
	my ($package,$col,$showmask,$label)=@{ $pages{$pid} };
	my $page=$package->new($col,\%opt1,\%opt2);
	$page->{pid}=$pid;
	$page->{masks}=$showmask;
	if ($col=~m/^\d+$/)
	{	$self->{$col}=$page;
		push @fieldlist,$col;
		$label=$::TagProp[$col][0];
	}
	$notebook->append_page( $page, Gtk2::Label->new($label) );
	if ($opt2{page} && $opt2{page} eq $pid) { $setpage=$notebook->get_n_pages-1 }
    }
    $self->{fieldlist}=\@fieldlist;

    $notebook->show_all; #needed to set page in this sub

    $_->show_all for $InterB,$optB;
    $_->set_no_show_all(1) for $spin,$InterB,$optB;
    $notebook->signal_connect(switch_page => sub
	{	my $p=$_[0]->get_nth_page($_[2]);
		$self->{page}=$p->{pid};
		my $mask=$p->{masks};
		if	($mask & 0b100)	{$optB->show}
		else			{$optB->hide}
		if	($mask & 0b010)	{$spin->show}
		else			{$spin->hide}
		if	($mask & 0b001)	{$InterB->show}
		else			{$InterB->hide}
	});

    $notebook->set_current_page( $setpage );

    $self->pack_end($hbox, FALSE, FALSE, 0) unless $opt1{hide};
    $self->add($notebook);
    $self->{resetbutton}=$ResetB;
    $self->{notebook}=$notebook;
    $self->{watcher}=::AddWatcher();
    $self->signal_connect(destroy => \&removewatchers);
    $self->{OnChangedFilter}=\&updatefilter;
    return $self;
}

sub SaveOptions
{	my $self=shift;
	my $opt='page='.$self->{page}.',min='.$self->{min};
	my $page=$self->{::SONG_ARTIST};
	$opt.=',artistpsize='.$page->{picsize}.',artistinfo='.$page->{showinfo}.',artistsort='.$page->{'sort'} if $page;
	$page=$self->{::SONG_ALBUM};
	$opt.=',albumpsize='.$page->{picsize}.',albuminfo='.$page->{showinfo}.',albumsort='.$page->{'sort'} if $page;
	return $opt;
}

sub updatefilter
{	my $self=shift;
	warn "Filtering list for FilterPane".$self->{nb}."\n" if $::debug;
	my $window=$self->get_toplevel;
	my $currentf=$window->{'Filter'.($self->{nb})};
	$self->{resetbutton}->set_sensitive( !Filter::is_empty($currentf) );
	my $filt=Filter->newadd(TRUE, map($window->{'Filter'.$_},0..($self->{nb}-1)) );
	return if $self->{list} && $filt->{string} eq $self->{filter}{string};
	$self->{filter}=$filt;

	my $lref=$filt->is_empty ? \@::Library
				 : $filt->filter;
	$self->{list}=$lref;

	my $updatesub=sub { ::IdleDo('9_FP'.$self,1000,\&update,$self); };
	my $addsub=sub { push @$lref,@_; &$updatesub; };
	my $rmsub=sub { my %h; $h{$_}=undef for @_; @$lref=grep !exists $h{$_},@$lref; &$updatesub; };
	my $refiltersub=sub { ::IdleDo('9_FPfull'.$self,5000,\&updatefilter,$self); };
	delete $::ToDo{'9_FP'.$self};
	delete $::ToDo{'9_FPfull'.$self};
	if ($lref eq \@::Library)
	{	$lref=undef;
		$addsub=$rmsub= $updatesub;	#don't need and MUSTN'T update @$lref
	}
	::ChangeWatcher( $self->{watcher},$lref,
		$self->{fieldlist},
		$updatesub,$rmsub,$addsub,$filt,$refiltersub );
	$self->update;
}

sub update
{  my ($self,$min)=@_;
   if (!$self->{list} || $::ToDo{'9_FPfull'.$self}) { $self->updatefilter; return; }
   warn "Updating FilterPane".$self->{nb}."\n" if $::debug;
   if ($min) { $self->{min}=$min; }
   if (!$min || $::ToDo{'9_FP'.$self})
   {	$self->{$_}{hash}=undef for @{ $self->{fieldlist} };
	delete $::ToDo{'9_FP'.$self};
   }
   for my $col (@{ $self->{fieldlist} })
   {	my $page=$self->{$col};
	$page->{valid}=0;		# set dirty flag for this col
	$page->Fill if $page->mapped;	# update now if col displayed
   }
}

sub removewatchers
{	my $self=shift;
	delete $::ToDo{'9_FP'.$self};
	delete $::ToDo{'9_FPfull'.$self};
	::RemoveWatcher( $self->{watcher} );
}

sub PopupAAOpt
{	my ($but,$event)=@_;
	my $self=::find_ancestor($but,__PACKAGE__);
	$::LEvent=$event;
	$::LEventW=$self->get_toplevel;
	my $nb=$self->{notebook};
	my $page=$nb->get_nth_page( $nb->get_current_page );
	::PopupContextMenu(\@MenuAAFPaneOptions, {self=>$page} );
	return 1;
}

package FilterList;
use Gtk2;
use strict;
no warnings;#use warnings;
use base 'Gtk2::VBox';

our @hashsub;
$hashsub[::SONG_DATE]= sub { my $lref=$_[0]; my %h; $h{ $::Songs[$_][::SONG_DATE] }++  for @$lref; return \%h };
$hashsub[::SONG_ALBUM]=sub { my $lref=$_[0]; my %h; $h{ $::Songs[$_][::SONG_ALBUM] }++ for @$lref; return \%h };
$hashsub[::SONG_ARTIST]=sub{ my $lref=$_[0]; my %h; $h{$_}++ for map split(/ ?& ?/,$::Songs[$_][::SONG_ARTIST]),@$lref; return \%h };
$hashsub[::SONG_GENRE]=sub { my $lref=$_[0]; my %h; $h{$_}++ for map split(/\x00/, $::Songs[$_][::SONG_GENRE]), @$lref; return \%h };
$hashsub[::SONG_FLAGS]=sub { my $lref=$_[0]; my %h; $h{$_}++ for map split(/\x00/, $::Songs[$_][::SONG_FLAGS]), @$lref; return \%h };
#$hashsub[::SONG_ARTIST]=sub { my $t=times;my $lref=$_[0]; my %h; $h{ $::Songs[$_][::SONG_ARTIST] }++  for @$lref;while (my($key,$v)=each %h) {my @k=split / ?& ?/,$key; if (@k>1) {$h{$_}+=$v for @k;delete $h{$key};}; }; warn (times-$t);return \%h };
#$hashsub[::SONG_GENRE]=sub { my $t=times;my $lref=$_[0]; my %h; $h{ $::Songs[$_][::SONG_GENRE] }++  for @$lref;while (my($key,$v)=each %h) {my @k=split /\x00/,$key; if (@k>1) {$h{$_}+=$v for @k;delete $h{$key};}; }; warn (times-$t);return \%h };


my @colcmd;
$colcmd[::SONG_DATE]	='e';
$colcmd[::SONG_ALBUM]	='e';
$colcmd[::SONG_ARTIST]	='~';
$colcmd[::SONG_GENRE]	='f';
$colcmd[::SONG_FLAGS]	='f';

my @cMenu;
INIT
{ @cMenu=
  (	{ label=> _"Play", code => sub { ::Select($_[0]{filter},undef,'first','play'); }, isdefined => 'filter', stockicon => 'gtk-media-play' },
	{ label=> _"Enqueue", code => sub { ::EnqueueFilter($_[0]{filter}); }, isdefined => 'filter', stockicon => 'gmb-queue' },
#	{ label=> _"Set Picture", test => sub { return 0 unless ($_[0]{col}==::SONG_ALBUM || $_[0]{col}==::SONG_ARTIST);  $_[0]{filter}->{string}=~m/^\d+[e~][^\x1D]+\x1D$/; },	code => sub { $_[0]{filter}->{string}=~m/^\d+[e~]([^\x1D]+)\x1D$/ && ::ChooseAAPicture(undef,$_[0]{col},$1); }, stockicon => 'gmb-picture'}
  );
}

sub new
{	my ($class,$col,$opt1,$opt2)=@_;
	my $self = bless Gtk2::VBox->new, $class;
	my $sw=Gtk2::ScrolledWindow->new(undef,undef);
	$sw->set_shadow_type('etched-in');
	$sw->set_policy('automatic','automatic');
	$self->{col}=$col;

	my $store=Gtk2::ListStore->new('Glib::String');
	$self->{treeview}=
	my $treeview=Gtk2::TreeView->new($store);
	$treeview->set_headers_visible(::FALSE);
	$treeview->set_enable_search(::TRUE);
	#$treeview->set('fixed-height-mode' => ::TRUE);	#only if fixed-size column
	my $renderer;
	if ($col==::SONG_ARTIST || $col==::SONG_ALBUM)
	{	$renderer=CellRendererAA->new;
		::Watch($self,'AAPicture',\&AAPicture_Changed);
		my $aa= ::SONG_ARTIST==$col ? 'artist' : 'album';
		$self->{picsize}=	$opt2->{$aa.'psize'}|| 0;
		$self->{showinfo}=	$opt2->{$aa.'info'} || 0;
		$self->{'sort'}=	$opt2->{$aa.'sort'} || 'alpha';
	}
	else  { $renderer=Gtk2::CellRendererText->new; }
	$treeview->append_column( Gtk2::TreeViewColumn->new_with_attributes
		( $::TagProp[$col][0],$renderer,'text',0)
		);

	#search box
	if ($col != ::SONG_DATE && $opt1->{searchbox})
	{	$self->{entry}=my $entry=Gtk2::Entry->new;	#FIXME tooltip
		my $clear=::NewIconButton('gtk-clear',undef,sub { my $self=::find_ancestor($_[0],__PACKAGE__); $self->{entry}->set_text(''); },'none' );	#FIXME tooltip
		my $hbox=Gtk2::HBox->new(::FALSE,0);
		$hbox->pack_end($clear,::FALSE,::FALSE,0);
		$hbox->pack_start($entry,::TRUE,::TRUE,0);
		$self->pack_start($hbox,::FALSE,::FALSE,1);
		$entry->signal_connect(changed =>
			sub {	my $entry=$_[0];
				::IdleDo('6_UpdateSearch'.$entry,300,sub
					{	my $self=::find_ancestor($entry,__PACKAGE__);
						my $s=$entry->get_text;
						return if defined $self->{search} && $self->{search} eq $s;
						$self->{search}=$s;
						$self->{valid}=0;
						$self->Fill;
					});
			    });
		$entry->signal_connect(activate =>
			sub {	::DoTask('6_UpdateSearch'.$entry);
			    });
	}

	$sw->add($treeview);
	$self->add($sw);
	$self->{store}=$store;
	$self->{colcmd}=$col.$colcmd[$col];

	$self->signal_connect(map => \&Fill);

	my $selection=$treeview->get_selection;
	$selection->set_mode('multiple');
	$selection->signal_connect (changed =>\&selection_changed_cb);

#	if ($col==::SONG_ALBUM || $col ==::SONG_ARTIST)
#	{	::set_drag($treeview, source => [($col==::SONG_ALBUM ? ::DRAG_ALBUM : ::DRAG_ARTIST),sub
#		 {	my @rows=$self->{treeview}->get_selection->get_selected_rows;
#			return map $store->get_value($store->get_iter($_),0) , @rows;
#		 }]);
#	}
#	else
#	{
	::set_drag( $treeview, source => [::DRAG_FILTER,sub
	    {	my $self=::find_ancestor($_[0],__PACKAGE__);
		my $filter=$self->get_selected_filters;
		return ($filter? $filter->{string} : undef);
	    }]);
#	}
	MultiTreeView::init($treeview,__PACKAGE__);

	my $sub=\&play_current;
	if ($opt1->{activate})
	{	$sub=\&enqueue_current	if $opt1->{activate} eq 'queue';
		$sub=\&add_current	if $opt1->{activate} eq 'addplay';
	}
	$treeview->signal_connect( row_activated => $sub);

	return $self;
}

sub AAPicture_Changed
{	my ($self,$key)=@_;
	return unless $self->{valid} && $self->{hash} && $self->{hash}{$key} && $self->{hash}{$key} >= ::find_ancestor($self,'FilterPane')->{min};
	$self->queue_draw;
}

sub selection_changed_cb
{	my $treesel=$_[0];
	my $self=::find_ancestor($treesel->get_tree_view,__PACKAGE__);
	return if $self->{busy};
	my $filter=$self->get_selected_filters;
	return unless $filter;
	my $filterpane=::find_ancestor($self,'FilterPane');
	$self->get_toplevel->SetFilter( $filterpane->{nb}, $filter );
}

sub get_selected_filters
{	my $self=::find_ancestor($_[0],__PACKAGE__);
	my @rows=$self->{treeview}->get_selection->get_selected_rows;
	return undef unless @rows;
	my $cmd=$self->{colcmd};
	my $col=$self->{col};
	my $store=$self->{store};
	my $filterpane=::find_ancestor($self,'FilterPane');
	my @vals=map $cmd.$store->get_value($store->get_iter($_),0) , @rows;
	my $i=$filterpane->{inter} && $col!=::SONG_ALBUM && $col!=::SONG_DATE;
	my $filter=Filter->newadd($i,@vals);
	$filter->invert if $filterpane->{invert};
	return $filter;
}

sub Fill
{	warn "filling @_\n" if $::debug;
	my $self=$_[0];
	return if $self->{valid};
	my $filterpane=::find_ancestor($self,'FilterPane');
	my $col=$self->{col};
	my $href= $self->{hash} ||= &{ $hashsub[$col] }($filterpane->{list});
	my $min=$filterpane->{min};
	my $store=$self->{store};
	$self->{busy}=1;
	$store->clear;	#FIXME keep selection
	(($self->{treeview}->get_columns)[0]->get_cell_renderers)[0]->reset if ($col==::SONG_ARTIST || $col==::SONG_ALBUM);
	my @l=grep $$href{$_} >= $min, keys %$href;
	my $search=$self->{search};
	@l=grep m/\Q$search\E/i, @l  if defined $search && $search ne '';
	if (!$self->{'sort'} || $self->{'sort'} eq 'alpha')
	{	@l=sort {lc$a cmp lc$b}
		   sort {$a cmp $b} @l;#the case-sensitive sort is used to speed up the following utf8 case-insensitive sort
	}
	elsif ($self->{'sort'} eq 'year')
	{	my $aa= $col==::SONG_ARTIST ? \%::Artist : \%::Album;
		@l=sort { $aa->{$a}[::AAYEAR] cmp $aa->{$b}[::AAYEAR] || lc$a cmp lc$b } @l;
	}
	$store->set($store->append,0,$_) for @l;

	$self->{busy}=undef;
	$self->{valid}=1;
}

sub add_current
{	::AddToPlaylist( get_selected_filters($_[0])->filter );
}
sub play_current
{	::Select( get_selected_filters($_[0]), undef,'first','play');
}
sub enqueue_current
{	::EnqueueFilter( get_selected_filters($_[0]) );
}
sub PopupContextMenu
{	my ($self,$tv,$event)=@_;
	$::LEvent=$event;
	::PopupContextMenu(\@cMenu, {self=>$self, filter => $self->get_selected_filters, col => $self->{col} });
}

package FolderList;
use Gtk2;
use strict;
#use warnings;
use base 'Gtk2::ScrolledWindow';

my @cMenu;
INIT
{ @cMenu=
  (	{ label=> _"Play", code => sub { ::Select($_[0]{filter},undef,'first','play'); }, isdefined => 'filter', stockicon => 'gtk-media-play' },
	{ label=> _"Enqueue", code => sub { ::EnqueueFilter($_[0]{filter}); }, isdefined => 'filter', stockicon => 'gmb-queue' },
	{ label=> _"rename folder", code => sub { ::AskRenameFolder($_[0]{utf8pathlist}[0]); }, onlyone => 'utf8pathlist' },
	#{ label=> _"move folder", code => sub { ::MoveFolder($_[0]{utf8pathlist}[0]); }, onlyone => 'utf8pathlist' },
	{ label=> _"Scan for new songs", code => sub { ::IdleScan( map(::filename_from_unicode($_), @{$_[0]{utf8pathlist}}) ); },
		notempty => 'utf8pathlist' },
	{ label=> _"Check for updated/removed songs", code => sub { ::IdleCheck(  @{ $_[0]{filter}->filter } ); },
		isdefined => 'filter', stockicon => 'gtk-refresh' },
  );
}

sub new
{   my ($class,$col)=@_;
    my $self = bless Gtk2::ScrolledWindow->new (undef, undef), $class;
    $self->set_shadow_type ('etched-in');
    $self->set_policy ('automatic', 'automatic');

    my $store=Gtk2::TreeStore->new('Glib::String');
    my $treeview=Gtk2::TreeView->new($store);
    $treeview->set_headers_visible(::FALSE);
    $treeview->set_enable_search(::TRUE);
    #$treeview->set('fixed-height-mode' => ::TRUE);	#only if fixed-size column
    $treeview->signal_connect(row_expanded  => \&row_expanded_changed_cb);
    $treeview->signal_connect(row_collapsed => \&row_expanded_changed_cb);
    $treeview->{expanded}={};
    $treeview->append_column( Gtk2::TreeViewColumn->new_with_attributes
		( $::TagProp[$col][0],Gtk2::CellRendererText->new,'text',0)
		);

    $self->add($treeview);
    $self->{treeview}=$treeview;

    $self->signal_connect(map => \&Fill);

    my $selection=$treeview->get_selection;
    $selection->set_mode('multiple');
    $selection->signal_connect (changed =>\&selection_changed_cb);
    ::set_drag($treeview, source => [::DRAG_FILTER,sub
	    {	my @paths=_get_path_selection( $_[0] );
		return undef unless @paths;
		my $filter=_MakeFolderFilter(@paths);
		return ($filter? $filter->{string} : undef);
	    }]);
    MultiTreeView::init($treeview,__PACKAGE__);
    return $self;
}

sub Fill
{	warn "filling @_\n" if $::debug;
	my $self=$_[0];
	return if $self->{valid};
	my $treeview=$self->{treeview};
	my $filterpane=::find_ancestor($self,'FilterPane');
	my $href=$self->{hash}||= do
		{ my %h; $h{ $::Songs[$_][::SONG_UPATH] }++ for @{ $filterpane->{list} };
		  my @hier;
		  while (my ($f,$n)=each %h)
		  {	my $ref=\@hier;
			$ref=$ref->[1]{$_}||=[] and $ref->[0]+=$n   for split /$::QSLASH/o,$f;
		  }
		  for my $dir (keys %{$treeview->{expanded}})
		  {	my $ref=\@hier; my $notfound;
			$ref=$ref->[1]{$_} or $notfound=1 and last  for split /$::QSLASH/o,$dir;
			if ($notfound)	{delete $treeview->{expanded}{$dir}}
			else		{ $ref->[2]=1; }
		  }
		  $hier[1]{::SLASH}=delete $hier[1]{''} if exists $hier[1]{''};
		  $hier[1];
		};
	my $min=$filterpane->{min};
	my $treeview=$self->{treeview};
	my $store=$treeview->get_model;
	$self->{busy}=1;
	$store->clear;	#FIXME keep selection

	#fill the store
	my @toadd; my @toexpand;
	push @toadd,$href->{$_},$_,undef  for sort grep $href->{$_}[0]>=$min, keys %$href;
	while (my ($ref,$name,$iter)=splice @toadd,0,3)
	{	my $iter=$store->append($iter);
		$store->set($iter,0,$name);
		push @toexpand,$store->get_path($iter) if $ref->[2];
		if ($ref->[1]) #sub-folders
		{ push @toadd, $ref->[1]{$_},$_,$iter  for sort grep $ref->[1]{$_}[0]>=$min, keys %{$ref->[1]}; }
	}

	# expand tree to first fork
	if (my $iter=$store->get_iter_first)
	{	$iter=$store->iter_children($iter) while $store->iter_n_children($iter)==1;
		$treeview->expand_to_path( $store->get_path($iter) );
	}
	#expand previously expanded rows
	$treeview->expand_row($_,::FALSE) for @toexpand;

	$self->{busy}=undef;
	$self->{valid}=1;
}

sub row_expanded_changed_cb	#keep track of which rows are expanded
{	my ($treeview,$iter,$path)=@_;
	my $self=::find_ancestor($treeview,__PACKAGE__);
	return if $self->{busy};
	my $expanded=$treeview->row_expanded($path);
	$path=_treepath_to_foldername($treeview->get_model,$path);
	my $ref=[undef,$self->{hash}];
	$ref=$ref->[1]{($_ eq '' ? ::SLASH : $_)}  for split /$::QSLASH/o,$path;
	if ($expanded)
	{	$ref->[2]=1;				#for when reusing the hash
		$treeview->{expanded}{$path}=undef;	#for when reconstructing the hash
	}
	else
	{	delete $ref->[2];
		delete $treeview->{expanded}{$path};
	}
}

sub selection_changed_cb
{	my $treesel=$_[0];
	my $self=::find_ancestor($treesel->get_tree_view,__PACKAGE__);
	return if $self->{busy};
	my @paths=_get_path_selection( $self->{treeview} );
	return unless @paths;
	my $filter=_MakeFolderFilter(@paths);
	my $filterpane=::find_ancestor($self,'FilterPane');
	$filter->invert if $filterpane->{invert};
	$self->get_toplevel->SetFilter( $filterpane->{nb}, $filter );
}

sub _MakeFolderFilter
{	my @paths=@_; #in utf8
	s/\\/\\\\/g for @paths;
	my $filter=Filter->newadd(::FALSE,map( ::SONG_UPATH.'i'.$_, @paths ));
}

sub enqueue_current
{	my $self=$_[0];
	my @paths=_get_path_selection( $self->{treeview} );
	::EnqueueFilter( _MakeFolderFilter(@paths) );
}
sub PopupContextMenu
{	my ($self,$tv,$event)=@_;
	my @paths=_get_path_selection($tv);
	$::LEvent=$event;
	::PopupContextMenu(\@cMenu, {self=>$tv, utf8pathlist => \@paths, filter => _MakeFolderFilter(@paths) });
}

sub _get_path_selection
{	my $treeview=$_[0];
	my $store=$treeview->get_model;
	my @paths=$treeview->get_selection->get_selected_rows;
	return () if @paths==0; #if no selection
	@paths=map _treepath_to_foldername($store,$_), @paths;
	return @paths;
}
sub _treepath_to_foldername
{	my ($store,$tp)=($_[0],$_[1]);
	my @folders;
	my $iter=$store->get_iter($tp);
	while ($iter)
	{	unshift @folders, $store->get_value($iter,0);
		$iter=$store->iter_parent($iter);
	}
	$folders[0]='' if $folders[0] eq ::SLASH;
	return join(::SLASH,@folders);
}

package SavedTree;
use Gtk2;
use strict;
use warnings;
use base 'Gtk2::VBox';

use constant { TRUE  => 1, FALSE => 0, };

our @cMenu; our %Modes;
INIT
{ @cMenu=
  (	{ label => _"new filter",	code => sub { ::EditFilter($_[0]{self},undef,''); },	stockicon => 'gtk-add' },
	{ label => _"edit filter",	code => sub { ::EditFilter($_[0]{self},undef,$_[0]{names}[0]); },
		mode => 'F',	onlyone => 'names' },
	{ label => _"remove filter",	code => sub { ::SaveFilter($_[0]{names}[0],undef); },
		mode => 'F',	onlyone => 'names',	stockicon => 'gtk-remove' },
	{ label => _"save current filter as",	code => sub { ::EditFilter($_[0]{self},$_[0]{curfilter},''); },
		 stockicon => 'gtk-save',	isdefined => 'curfilter',	test => sub { ! $_[0]{curfilter}->is_empty; } },
	{ label => _"save current list as",	code => sub { $_[0]{self}->CreateNewFL('L',\@{ $_[0]{songlist}{array} }); },
		stockicon => 'gtk-save',	isdefined => 'songlist' },
	{ label => _"edit list",	code => sub { ::WEditList( $_[0]{names}[0] ); },
		mode => 'L',	onlyone => 'names' },
	{ label => _"remove list",	code => sub { ::SaveList($_[0]{names}[0],undef); },
		stockicon => 'gtk-remove',	mode => 'L' },
	{ label => _"rename",	code => sub { my $tv=$_[0]{self}->{treeview}; $tv->set_cursor($_[0]{treepaths}[0],$tv->get_column(0),TRUE); },
		notempty => 'names',	onlyone => 'treepaths' },
	{ label => _"enqueue", code => sub { ::Enqueue(@{ $_[0]{sumfilter}->filter }); },
		 stockicon => 'gmb-queue',		isdefined => 'sumfilter' },
  );

  %Modes=
  (	F => [_"Saved filters",	'sfilter',	'SavedFilters',	\&UpdateSavedFilters	],
	L => [_"Saved lists",	'slist',	'SavedLists',	\&UpdateSavedLists	],
  );
}

sub new
{	my ($class,$mode)=@_;
	my $self = bless Gtk2::VBox->new(FALSE, 4), $class;
	my $store=Gtk2::TreeStore->new('Glib::String','Glib::String','Glib::Boolean');
	$self->{treeview}=my $treeview=Gtk2::TreeView->new($store);
	$treeview->set_headers_visible(FALSE);
	my $renderer=Gtk2::CellRendererText->new;
	$renderer->signal_connect(edited => \&name_edited_cb,$self);
	$treeview->append_column
		( Gtk2::TreeViewColumn->new_with_attributes
		  ('Filters', $renderer, text => 0, editable =>2)
		);

	::set_drag($treeview, source =>
		[::DRAG_FILTER,sub
		 {	my $filter=$self->get_selected_filters;
			return ($filter? $filter->{string} : undef);
		 }],
		 dest =>
		[::DRAG_FILTER,::DRAG_ID,sub	#targets are modified in drag_motion callback
		 {	my ($treeview,$type,$dest,@data)=@_;
			my (undef,$path)=@$dest;
			my ($name,$rowtype)=$store->get_value( $store->get_iter($path) );
			if ($type == ::DRAG_ID)
			{	if ($rowtype eq 'slist')
				{	push @{$::SavedLists{$name}},@data;
					::HasChanged('SavedLists',$name,'push');
				}
				else
				{	$self->CreateNewFL('L',\@data);
				}
			}
			elsif ($type == ::DRAG_FILTER)
			{	$self->CreateNewFL('F', Filter->new($data[0]) );
			}
		 }],
	 	motion => \&drag_motion_cb);

	MultiTreeView::init($treeview,__PACKAGE__);
	$treeview->signal_connect( row_activated	=> \&row_activated_cb);
	my $selection=$treeview->get_selection;
	$selection->set_mode('multiple');
	$selection->signal_connect( changed => \&sel_changed_cb);

	my $sw=Gtk2::ScrolledWindow->new(undef,undef);
	$sw->set_shadow_type('etched-in');
	$sw->set_policy('automatic','automatic');
	$sw->add($treeview);
	$self->add($sw);
	$self->{store}=$store;

	$mode||='FL';
	my $n=0;
	for (split //,$mode)
	{	my ($label,$id,$watchid,$sub)=@{ $Modes{$_} };
		if (length($mode)!=1)
		{	$store->set($store->append(undef),0,$label,1,'root-'.$id);
			$self->{$id}=$n++;
		}
		::Watch($self,$watchid,$sub);
		&$sub($self);
	}
	$treeview->expand_all;

	return $self;
}

sub UpdateSavedFilters
{	$_[0]->fill_savednames('sfilter',\%::SavedFilters);
}
sub UpdateSavedLists
{	return if $_[2] && $_[2] eq 'push';
	$_[0]->fill_savednames('slist',\%::SavedLists);
}
sub fill_savednames
{	my ($self,$type,$href)=@_;
	$self->{busy}=1;
	my $treeview=$self->{treeview};
	my $store=$treeview->get_model;
	my $path;
	my $expanded; my $iter;
	if (defined $self->{$type})
	{	$path=Gtk2::TreePath->new( $self->{$type} );
		$expanded=$treeview->row_expanded($path);
		$iter=$store->get_iter($path);
		$expanded=1 unless $store->iter_has_child($iter);
	}
	while (my $child=$store->iter_children($iter))
	{	$store->remove($child);
	}
	$store->set($store->append($iter),0,$_,1,$type,2,TRUE) for sort keys %$href;
	$treeview->expand_to_path($path) if $expanded;
	$self->{busy}=undef;
}

sub enqueue_current {}
sub PopupContextMenu
{	my ($self,$tv,$event)=@_;
	my @rows=$tv->get_selection->get_selected_rows;
	my $store=$tv->get_model;
	my %sel;
	for my $path (@rows)
	{	my ($name,$type)=$store->get_value($store->get_iter($path));
		next if $type=~m/^root-/;
		push @{ $sel{$type} },$name;
	}
	my %args=(self=> $self);
	if ((keys %sel)==1)
	{	my ($mode)=($args{mode})=keys %sel;
		$args{mode}=	$mode eq 'sfilter'	? 'F' :
				$mode eq 'slist'	? 'L' :
				undef;
		$args{names}=$sel{$mode};
	}
	$args{treepaths}=\@rows;
	$args{songlist}=$self->get_toplevel->{songlist} if $self->get_toplevel->{songlist};
	$args{curfilter}=$self->get_toplevel->{Filter};
	$args{sumfilter}=$self->get_selected_filters;
	$::LEvent=$event;
	::PopupContextMenu(\@cMenu,\%args);
}

sub drag_motion_cb
{	my ($treeview,$context,$x,$y,$time)=@_;
	::drag_checkscrolling($treeview,$context,$y);
	my $store=$treeview->get_model;
	my ($path,$pos)=$treeview->get_dest_row_at_pos($x,$y);
	my $status;
	{	last if !$path || $treeview->{drag_is_source};
		my $type=$store->get_value( $store->get_iter($path) ,1);
		last unless $type;
		my $target_id=[$::DRAGTYPES[::DRAG_ID][0],'same-app',::DRAG_ID];
		my $target_filter=[$::DRAGTYPES[::DRAG_FILTER][0],[],::DRAG_FILTER];
		my $lookfor; my @targets;
		if ($type eq 'root-sfilter')
		{	$lookfor=::DRAG_FILTER;
			@targets=($target_filter,$target_id);
		}
		elsif ($type=~m/slist$/)
		{	$lookfor=::DRAG_ID;
			@targets=($target_id,$target_filter);
		}
		else {last}

		if ($lookfor && grep $::DRAGTYPES{$_->name} ==$lookfor, $context->targets)
		{	$status='copy';
			$treeview->drag_dest_set_target_list(Gtk2::TargetList->new( @targets ));
		}
	}
	unless ($status) { $status='default'; $path=undef; }
	$context->{dest}=[$treeview,$path];
	$treeview->set_drag_dest_row($path,'into-or-after');
	$context->status($status, $time);
	return 1;
}

sub row_activated_cb
{	my ($treeview,$path,$column)=@_;
	$treeview->set_cursor($path,$column,TRUE);
}

sub name_edited_cb
{	my ($cell, $path_string, $newname,$self) = @_;
	my $store=$self->{store};
	my $iter=$store->get_iter( Gtk2::TreePath->new($path_string) );
	my ($name,$type)=$store->get($iter,0,1);
	my $sub= $type eq 'sfilter' ? \&::SaveFilter : \&::SaveList;
	#$self->{busy}=1;
	&$sub($name,undef,$newname);
	#$self->{busy}=undef;
	#$store->set($iter, 0, $newname);
}

sub CreateNewFL
{	my ($self,$mode,$data)=@_;
	my ($type,$name,$savesub,$hash)= ($mode eq 'F') ? ('sfilter','filter000',\&::SaveFilter,\%::SavedFilters)
							: ('slist','list000',\&::SaveList,\%::SavedLists);
	while ($hash->{$name}) {$name++}
	return if $hash->{$name};
	&$savesub($name,$data);

	my $treeview=$self->{treeview};
	my $store=$treeview->get_model;
	my $iter;
	if (defined $self->{$type})
	{	my $path=Gtk2::TreePath->new( $self->{$type} );
		$iter=$store->get_iter($path);
	}
	$iter=$store->iter_children($iter);
	while ($iter)
	{	last if $store->get($iter,0) eq $name;
		$iter=$store->iter_next($iter);
	}
	return unless $iter;
	my $path=$store->get_path($iter);
	$self->{busy}=1;
	$treeview->set_cursor($path,$treeview->get_column(0),TRUE);
	$self->{busy}=undef;
}

sub sel_changed_cb
{	my $treesel=$_[0];
	my $self=::find_ancestor($treesel->get_tree_view,__PACKAGE__);
	return if $self->{busy};
	my $filter=$self->get_selected_filters;
	return unless $filter;
	my $filterpane=::find_ancestor($self,'FilterPane');
	$self->get_toplevel->SetFilter( $filterpane->{nb}, $filter );
}

sub get_selected_filters
{	my $self=shift;
	my $store=$self->{store};
	my @filters;
	for my $path ($self->{treeview}->get_selection->get_selected_rows)
	{	my ($name,$type)=$store->get_value($store->get_iter($path));
		next unless $type;
		if ($type eq 'sfilter') {push @filters,$::SavedFilters{$name};}
		elsif ($type eq 'slist'){push @filters,'l'.$name;}
	}
	return undef unless @filters;
	my $filterpane=::find_ancestor($self,'FilterPane');
	my $filter=Filter->newadd( $filterpane->{inter},@filters );
	$filter->invert if $filterpane->{invert};
	return $filter;
}

package AABox;
use Gtk2;
use strict;
use base 'Gtk2::EventBox';

use constant { TRUE  => 1, FALSE => 0, };

sub new
{	my ($class,$opt1)= @_;
	$opt1='aa='.( $opt1 ? 'artist' : 'album') if defined $opt1 && $opt1!~m/=/; #for version <0.9479
	my %opt1;
	if ($opt1)	{ $opt1{$1}=$2 while $opt1=~m/(\w+)=([^,]*)(?:,|$)/g; }
	my $self = bless Gtk2::EventBox->new, $class;
	my $col= $opt1{aa} eq 'artist' ? ::SONG_ARTIST : ::SONG_ALBUM;
	$self->{Col}=$col;
	$self->{filternb}= exists $opt1{filternb} ? $opt1{filternb} : 1;
	my $hbox = Gtk2::HBox->new (FALSE, 6);
	$self->add($hbox);
	($self->{AAref},$self->{fcmd})= $col==::SONG_ARTIST ? (\%::Artist,$col.'~') : (\%::Album,$col.'e');
	$self->{Sel}='';
	$self->{SelID}=-1;
	my $vbox = Gtk2::VBox->new(FALSE, 0);
	for my $name (qw/Ltitle Lstats/)
	{	my $l=Gtk2::Label->new('');
		$self->{$name}=$l;
		$l->set_justify('center');
		if ($name eq 'Ltitle')
		{	$l->set_line_wrap(TRUE);
			#$l->set_justify('center');
			my $b=Gtk2::Button->new;
			$b->set_relief('none');
			$b->signal_connect(button_press_event => \&AABox_button_press_cb);
			$b->add($l);
			$l=$b;
		}
		$vbox->pack_start($l, FALSE,FALSE, 2);
	}

	my $pixbox=Gtk2::EventBox->new;
	$self->{img}=my $img=Gtk2::Image->new;
	$img->{size}=0;
	$img->signal_connect(size_allocate => \&size_allocate_cb);
	$pixbox->add($img);
	$pixbox->signal_connect(button_press_event => \&::pixbox_button_press_cb,1); # 1 : mouse button 1

	my $buttonbox=Gtk2::VBox->new(FALSE, 4);
	my $Bfilter=::NewIconButton('gmb-filter',undef,sub { $self->filter },'none');
	$::Tooltips->set_tip($Bfilter, ($col==::SONG_ARTIST ? _"Filter on this artist" : _"Filter on this album") );
	my $Bplay=::NewIconButton('gtk-media-play',undef,sub
		{  return if $self->{SelID}==-1;
		   ::Select($self->{fcmd}.$self->{Sel},undef,'first','play');
		},'none');
	$::Tooltips->set_tip($Bplay, ($col==::SONG_ARTIST ? _"Play all songs from this artist" : _"Play all songs from this album") );
	$buttonbox->pack_start($_, FALSE, FALSE, 0) for ($Bfilter,$Bplay);

	$hbox->pack_start($pixbox, FALSE, TRUE, 0);
	$hbox->pack_start($vbox, TRUE, FALSE, 0);
	$hbox->pack_start($buttonbox, FALSE, FALSE, 0);

	if ($col==::SONG_ARTIST)
	{	$self->{'index'}=0;
		$self->signal_connect(scroll_event => \&AABox_scroll_event_cb);
		my $BAlblist=::NewIconButton('gmb-playlist',undef,undef,'none');
		$BAlblist->signal_connect(button_press_event => \&AlbumListButton_press_cb,$self);
		$::Tooltips->set_tip($BAlblist,_"Choose Album From this Artist");
		$buttonbox->pack_start($BAlblist, FALSE, FALSE, 0);
	}
	#else
	#{	#my $BAlblist=::NewIconButton('gmb-playlist',undef,undef,'none');
		#$buttonbox->pack_start($BAlblist, FALSE, FALSE, 0);
		#$BAlblist->signal_connect ('clicked' => sub
		#{	$self->{list}^=1;
		#	$self->update();
		#});
		#my $store=Gtk2::ListStore->new('Glib::String');
		#my $treeview=Gtk2::TreeView->new($store);
		#$treeview->append_column( Gtk2::TreeViewColumn->new_with_attributes
		#( 'albums from artist',Gtk2::CellRendererText->new,'text',0)
		#);
		#my $sw = Gtk2::ScrolledWindow->new (undef, undef);
		#$sw->set_shadow_type ('etched-in');
		#$sw->set_policy ('automatic', 'automatic');
		#$sw->add($treeview);
	#}

	::set_drag($self, source =>
	 [($col==::SONG_ARTIST ? ::DRAG_ARTIST : ::DRAG_ALBUM), sub { $_[0]->{Sel}; } ],
	 dest => [::DRAG_ID,::DRAG_FILE,sub
	 {	my ($self,$type,@values)=@_;
		if ($type==::DRAG_FILE)
		{	my $key=$self->{Sel};
			my $AAref=$self->{AAref};
			my $file=$values[0];
			if ($file=~s#^file://##)
			{	$AAref->{$key}[::AAPIXLIST]=::decode_url($file);
				::HasChanged('AAPicture',$key);
			}
			#else #FIXME download http link, ask filename
		}
		else # $type is ID
		{	$self->id_set($values[0]);
		}
	 }]);

	$self->signal_connect(button_press_event => \&AABox_button_press_cb);
	::Watch($self,'AAPicture',\&AAPicture_Changed);
	$self->{OnChangedID}=\&id_set;
	$self->{watcher_list}=::AddWatcher();
	$self->{watcher_id}=::AddWatcher();
	$self->signal_connect(destroy => \&remove);
	return $self;
}
sub remove
{	my $self=shift;
	delete $::ToDo{'9_AABox'.$self};
	::RemoveWatcher($self->{watcher_id});
	::RemoveWatcher($self->{watcher_list});
}

sub AAPicture_Changed
{	my ($self,$key)=@_;
	$self->pic_set( $self->{AAref}{ $self->{Sel} }[::AAPIXLIST] ) if $key eq $self->{Sel};
}

sub update_id
{	my $self=shift;
	my $ID=$self->{SelID};
	$self->{SelID}=-1;
	$self->{Sel}='';
	$self->id_set($ID);
}

sub clear
{	my $self=shift;
	$self->{SelID}=-1;
	$self->{Sel}='';
	$self->pic_set(undef);
	$self->{$_}->set_text('') for qw/Ltitle Lstats/;
	::ChangeWatcher($self->{watcher_id});
	::ChangeWatcher($self->{watcher_list});
	delete $::ToDo{'9_AABox'.$self};
}

sub id_set
{	my ($self,$ID)=@_;
	return if $self->{SelID}==$ID;
	$self->{SelID}=$ID;
	::ChangeWatcher($self->{watcher_id},[$ID],$self->{Col},
		sub {$self->update_id}, sub {$self->clear;} );
	my $key=$::Songs[$ID][ $self->{Col} ];
	if ( $self->{Col}==::SONG_ARTIST )
	{	my @l=split / ?& ?/,$::Songs[$ID][::SONG_ARTIST];
		$self->{'index'}%=@l;
		$key=$l[$self->{'index'}];
	}
	$self->update($key) unless $key eq $self->{Sel};
}

sub update
{	my ($self,$key)=@_;
	#return if $self->{Sel} eq $key;
	if (defined $key) { $self->{Sel}=$key; }
	else		  { $key=$self->{Sel}; }
	my $col=$self->{Col};
	my $AAref=$self->{AAref}{$key};
	#FIXME check if undef ??
	my $Listref=$AAref->[::AALIST];
	#set picture
	$self->pic_set($AAref->[::AAPIXLIST]);
	#set labels
	#########	title
	$self->{Ltitle}->set_markup( ::ReplaceAAFields($key,"<big><b>%a</b></big>",$col,1) );
	$self->{Lstats}->set_markup( ::ReplaceAAFields($key,"%s\n%X\n<small>%L\n%y</small>",$col,1) );
	#########	nb songs
#	$self->{Lnbsong}->set_markup( ::ReplaceAAFields($key,"%s",$col,1) );
	#########	nb artists/albums
#	$self->{LnbAA}->set_markup( ::ReplaceAAFields($key,"%X",$col,1) );
	##########	length
#	$self->{Llength}->set_markup( ::ReplaceAAFields($key,"<small>%L</small>",$col,1) );
	##########	years
#	$self->{Lyears}->set_markup( ::ReplaceAAFields($key,"<small>%y</small>",$col,1) );

	delete $::ToDo{'9_AABox'.$self};
	my $updatesub=sub
	{	::IdleDo('9_AABox'.$self,1000,\&update,$self);
		::ChangeWatcher($self->{watcher_list}); #inactivate watcher
	};
	::ChangeWatcher($self->{watcher_list},$Listref,
		[::SONG_ALBUM,::SONG_ARTIST,::SONG_LENGTH,::SONG_SIZE,::SONG_DATE],
		$updatesub,$updatesub,$updatesub);
}

sub filter
{	my $self=shift;
	return if $self->{SelID}==-1;
	$self->get_toplevel->SetFilter( $self->{filternb}, $self->{fcmd}.$self->{Sel} );
}

sub pic_set
{	my ($self,$file)=@_;
	my $img=$self->{img};
	::ScaleImageFromFile( $img, $img->{size}, $file );
}

sub size_allocate_cb
{	my ($img,$alloc)=@_;
	my $h=$alloc->height;
	$h=200 if $h>200;		#FIXME use a relative max value (to what?)
	return if abs($img->{size}-$h)<6;
	$img->{size}=$h;
	::ScaleImage( $img, $img->{size} );
}

sub AABox_button_press_cb			#popup menu
{	my ($self,$event)=@_;
	if ($self->isa('AABox'))
	{	return 0 unless $event->button == 3;
	}
	else
	{	while ($self=$self->parent) { last if $self->isa('AABox'); }
		return unless $self;
	}
	return if $self->{SelID}==-1;
	$::LEvent=$event;
	$::LEventW=$self->get_toplevel;
	::PopupContextMenu(\@::cMenuAA,{self=>$self, col=>$self->{Col}, key=>$self->{Sel}, ID=>$self->{SelID}, filternb => $self->{filternb}, mode => 'B'});
	return 1;
}

sub AABox_scroll_event_cb
{	my ($self,$event)=@_;
	my @l=split / ?& ?/,$::Songs[$self->{SelID}][::SONG_ARTIST];
	return 0 unless @l>1;
	$self->{'index'}+=($event->direction eq 'up')? 1 : -1;
	$self->{'index'}%=@l;
	$self->update( $l[$self->{'index'}] );
	1;
}

sub AlbumListButton_press_cb
{	(undef,$::LEvent,my $self)=@_;
	$::LEventW=$self->get_toplevel;
	return if $self->{Sel} eq '';
	::PopupAA(::SONG_ALBUM,$self->{Sel},sub
		{	my $key=$_[1];
			$self->get_toplevel->SetFilter( $self->{filternb}, ::SONG_ALBUM.'e'.$key );
		});
	1;
}

package SongSearch;
use base 'Gtk2::VBox';

sub new
{	my ($class,$opt1)=@_;
	my %opt1;
	if ($opt1)	{ $opt1{$1}=$2 while $opt1=~m/(\w+)=([^,]*)(?:,|$)/g; }
	my $self= bless Gtk2::VBox->new, $class;
	my $activate= $opt1{activate} || 'queue';
	$self->{songlist}=
	my $songlist=SongList->new('S','headers=off,activate='.$activate,'sort='.::SONG_TITLE.',cols='.::SLC_TITLEAA);
	my $hbox1=Gtk2::HBox->new;
	my $entry=Gtk2::Entry->new;
	$entry->signal_connect(changed => \&EntryChanged_cb,0);
	$entry->signal_connect(activate =>\&EntryChanged_cb,1);
	$hbox1->pack_start( Gtk2::Label->new(_"Search : ") , ::FALSE,::FALSE,2);
	$hbox1->pack_start($entry, ::TRUE,::TRUE,2);
	$self->pack_start($hbox1, ::FALSE,::FALSE,2);
	$self->add($songlist);
	if ($opt1{buttons})
	{	my $hbox2=Gtk2::HBox->new;
		my $Bqueue=::NewIconButton('gmb-queue',     _"Enqueue",	sub { $songlist->EnqueueSelected; });
		my $Bplay= ::NewIconButton('gtk-media-play',_"Play",	sub { $songlist->PlaySelected; });
		my $Bclose=::NewIconButton('gtk-close',     _"Close",	sub {$self->get_toplevel->close_window});
		$hbox2->pack_end($_, ::FALSE,::FALSE,4) for $Bclose,$Bplay,$Bqueue;
		$self->pack_end($hbox2, ::FALSE,::FALSE,0);
	}

	return $self;
}

sub EntryChanged_cb
{	my ($entry,$force)=@_;
	my $text=$entry->get_text;
	my $self=::find_ancestor($entry,__PACKAGE__);
	my $songlist=$self->{songlist};
	if (!$force && 2>length $text) { $songlist->Empty }
	else { $songlist->SetFilter( Filter->new(::SONG_TITLE.'s'.$text) ); }
}

package AASearch;
use base 'Gtk2::VBox';

sub new
{	my ($class,$opt1)=@_;
	my %opt1;
	if ($opt1)	{ $opt1{$1}=$2 while $opt1=~m/(\w+)=([^,]*)(?:,|$)/g; }
	my $self= bless Gtk2::VBox->new, $class;
	my $sw=Gtk2::ScrolledWindow->new(undef, undef);
	$sw->set_shadow_type ('etched-in');
	$sw->set_policy ('automatic', 'automatic');
	my $store=Gtk2::ListStore->new('Glib::String');
	$self->{treeview}=
	 my $treeview=Gtk2::TreeView->new($store);
	$treeview->set_headers_visible(::FALSE);
	$treeview->append_column( Gtk2::TreeViewColumn->new_with_attributes
		( '', CellRendererAA->new, 'text',0)
		);
	my $sub=\&Enqueue;
	$sub=\&AddToPlaylist if $opt1{activate} && $opt1{activate} eq 'addplay';
	$treeview->signal_connect( row_activated => $sub);
	my $col=$self->{col}= ($opt1{aa} && $opt1{aa} eq 'artist' ? ::SONG_ARTIST : ::SONG_ALBUM );
	$self->{picsize}=32; $self->{showinfo}=1; $self->{col}=$col;

	::set_drag($treeview, source => [($col==::SONG_ALBUM ? ::DRAG_ALBUM : ::DRAG_ARTIST),
	    sub
	    {	my @rows=$self->{treeview}->get_selection->get_selected_rows;
		return map $store->get_value($store->get_iter($_),0) , @rows;
	    }]);

	$self->{cmd}= $col==::SONG_ARTIST ? '~' : 'e';
	my $hbox1=Gtk2::HBox->new;
	my $entry=Gtk2::Entry->new;
	$entry->signal_connect(changed => \&EntryChanged_cb,0);
	$entry->signal_connect(activate=> \&EntryChanged_cb,1);
	$hbox1->pack_start( Gtk2::Label->new(_"Search : ") , ::FALSE,::FALSE,2);
	$hbox1->pack_start($entry, ::TRUE,::TRUE,2);
	$sw->add($treeview);
	$self->pack_start($hbox1, ::FALSE,::FALSE,2);
	$self->add($sw);
	if ($opt1{buttons})
	{	my $hbox2=Gtk2::HBox->new;
		my $Bqueue=::NewIconButton('gmb-queue',     _"Enqueue",	\&Enqueue);
		my $Bplay= ::NewIconButton('gtk-media-play',_"Play",	\&Play);
		my $Bclose=::NewIconButton('gtk-close',     _"Close",	sub {$self->get_toplevel->close_window});
		$hbox2->pack_end($_, ::FALSE,::FALSE,4) for $Bclose,$Bplay,$Bqueue;
		$self->pack_end($hbox2, ::FALSE,::FALSE,0);
	}

	return $self;
}

sub GetFilter
{	my $self=::find_ancestor($_[0],__PACKAGE__);
	my $treeview=$self->{treeview};
	my $path=($treeview->get_cursor)[0];
	return undef unless $path;
	my $store=$treeview->get_model;
	my $aa=$store->get( $store->get_iter($path) );
	return Filter->new( $self->{col}.$self->{cmd}.$aa );
}

sub EntryChanged_cb
{	my ($entry,$force)=@_;
	my $text=$entry->get_text;
	my $self=::find_ancestor($entry,__PACKAGE__);
	my $ref= $self->{col}==::SONG_ARTIST ? \%::Artist : \%::Album;
	my $store=$self->{treeview}->get_model;
	(($self->{treeview}->get_columns)[0]->get_cell_renderers)[0]->reset;
	$store->clear;
	return if !$force && 2>length $text;
	my $re=qr/\Q$text\E/i;
	$store->set($store->append,0,$_) for sort {lc$a cmp lc$b} grep m/$re/, keys %$ref;
}

sub Enqueue
{	my $filter=GetFilter($_[0]);
	::EnqueueFilter($filter) if $filter;
}
sub Play
{	my $filter=GetFilter($_[0]);
	::Select($filter,undef,'first','play') if $filter;
}
sub AddToPlaylist
{	my $filter=GetFilter($_[0]);
	return unless $filter;
	my $list=$filter->filter;
	::AddToPlaylist($list);
}

package CellRendererIconList;
use Glib::Object::Subclass
	'Gtk2::CellRenderer',
	properties => [ Glib::ParamSpec->scalar
			('iconlist',		 #name
			 'iconlist',		 #nickname
			 '\x00-separated list of stock-id', #blurb
			 [qw/readable writable/] #flags
		 	)
		      ];

use constant PAD => 2;

sub GET_SIZE
{	my ($cell, $widget, $cell_area) = @_;
	my $list=$cell->get('iconlist');
	return (0,0,0,0) unless defined $list;
	my $nb=@{[ split /\x00/,$list ]};
	#my ($w,$h)=Gtk2::IconSize->lookup( $cell->get('stock-size') );
	my ($w,$h)=Gtk2::IconSize->lookup( 'menu' );
	return (0,0, $nb*($w+PAD)+$cell->get('xpad')*2, $h+$cell->get('ypad')*2);
}

sub RENDER
{	my ($cell, $window, $widget, $background_area, $cell_area, $expose_area, $flags) = @_;
	my $list=$cell->get('iconlist');
	return unless defined $list;
	#my $size=$cell->get('stock-size');
	my $size='menu';
	my $state;
	if ($flags & 'selected')
	{	$state = $widget->has_focus ? 'selected' : 'active';
	}
	else
	{	$state = $widget->state eq 'insensitive' ? 'insensitive' : 'normal';
	}
	my ($w,$h)=Gtk2::IconSize->lookup($size);
	my $room=PAD + $cell_area->height-2*$cell->get('ypad');
	my $nb=int( ($room) / ($h+PAD) );
	my $x=$cell_area->x+$cell->get('xpad');
	my $y=$cell_area->y+$cell->get('ypad');
	$y+=int( $cell->get('yalign') * ($room-($h+PAD)*$nb) ) if $nb>0;
	my $row=0; my $ystart=$y;
	for my $stock ( sort split /\x00/,$list )
	{	my $pb=$widget->render_icon('flag-'.$stock, $size );
		next unless $pb;
		$window->draw_pixbuf( $widget->style->fg_gc($state), $pb,0,0,
				$x,$y,-1,-1,'none',0,0);
		$row++;
		if ($row<$nb)	{ $y+=PAD+$h; }
		else		{ $row=0; $y=$ystart; $x+=PAD+$w; }
	}
}

package CellRendererAA;
use Glib::Object::Subclass 'Gtk2::CellRendererText';

use constant PAD => 2;

sub makelayout
{	my ($cell,$widget)=@_;
	my $text=$cell->get('text');
	my $layout=Gtk2::Pango::Layout->new( $widget->create_pango_context );
	if ($widget->parent->parent->{showinfo})
	{	my $col= $widget->parent->parent->{col};
		$text=::ReplaceAAFields( $text,"<b>%a</b>%Y\n<small>%s <small>%l</small></small>",$col,::TRUE );
		$layout->set_markup($text);
		#$text.="\n".@{$ref->[::AALIST]}.' songs '.$s;
	}
	else { $layout->set_text($text); }
	return $layout;
}

sub GET_SIZE
{	my ($cell, $widget, $cell_area) = @_;
	my $layout=$cell->makelayout($widget);
	my ($w,$h)=$layout->get_pixel_size;
	my $s=$widget->parent->parent->{picsize};
	$h=$s if $h<$s;
	return (0,0,$w+$s+PAD+$cell->get('xpad')*2,$h+$cell->get('ypad')*2);
}

sub RENDER
{	my ($cell, $window, $widget, $background_area, $cell_area, $expose_area, $flags) = @_;
	my $s=$widget->parent->parent->{picsize};
	my $x=$cell_area->x;
	my $y=$cell_area->y;
	my $text=$cell->get('text');
	my $layout=$cell->makelayout($widget);
	my ($w,$h)=$layout->get_pixel_size;
	$w+=PAD+$s;
	my $offy=$cell->get('ypad');
	if ($s>$h)
	{	$offy+=int( $cell->get('yalign')*($s-$h) );
		$h=$s;
	}

	my $state;
	if ($flags & 'selected')
	{	$state = $widget->has_focus ? 'selected' : 'active';
	}
	else
	{	$state = $widget->state eq 'insensitive' ? 'insensitive' : 'normal';
	}
	{	last unless $s;
		my $col=$widget->parent->parent->{col};
		my $pixbuf= AAPicture::pixbuf($col,$text, $s);
		if ($pixbuf)
		{	my $offy=int(($s-$pixbuf->get_height)/2);#center pic
			my $offx=int(($s-$pixbuf->get_width )/2);
			$window->draw_pixbuf( $widget->style->fg_gc($state), $pixbuf,0,0,
				$x+$offx+$cell->get('xpad'),
				$y+$offy+$cell->get('ypad'),-1,-1,'none',0,0);
		}
		elsif (defined $pixbuf)
		{	my ($tx,$ty)=$widget->widget_to_tree_coords($x,$y);
			$cell->{idle}||=Glib::Idle->add(\&idle,$cell);
			$cell->{widget}||=$widget;
			$cell->{queue}{$ty}=[$window,$tx,$ty,$text,$state,$w,$h];
		}
	}

	$widget -> get_style -> paint_layout($window, $state, 1,
		$cell_area, $widget, undef,
		$x+$s+PAD + $cell->get('xpad'),
		$y+$offy,
		$layout);
}

sub reset
{	my $cell=$_[0];
	delete $cell->{queue};
	Glib::Source->remove( $cell->{idle} ) if $cell->{idle};
	delete $cell->{idle};
}

sub idle
{	my $cell=$_[0];
	{	last unless $cell->{queue} && $cell->{widget}->mapped;
		my ($x,$ref)=each %{ $cell->{queue} };
		last unless $ref;
		delete $cell->{queue}{$x};
		$cell->drawpix($cell->{widget},@$ref);
		last unless scalar keys %{ $cell->{queue} };
		return 1;
	}
	delete $cell->{queue};
	delete $cell->{widget};
	return $cell->{idle}=undef;
}

sub drawpix
{	my ($cell,$widget,$window,$ctx,$cty,$text,$state,$w,$h)=@_;
	my ($vx,$vy,$vw,$vh)=$widget->get_visible_rect->values;
	#warn "   $text\n";
	return if $vx > $ctx+$w || $vy > $cty+$h || $vx+$vw < $ctx || $vy+$vh < $cty; #no longer visible
	#warn "DO $text\n";
	my ($x,$y)=$widget->tree_to_widget_coords($ctx,$cty);
	my $col=$widget->parent->parent->{col};
	my $s= $widget->parent->parent->{picsize};
	my $pixbuf= AAPicture::pixbuf($col,$text, $s,1);
	return unless $pixbuf;

	my $offy=int( ($s-$pixbuf->get_height)/2 );#center pic
	my $offx=int( ($s-$pixbuf->get_width )/2 );
	$window->draw_pixbuf( $widget->style->fg_gc($state), $pixbuf,0,0,
		$x+$offx+$cell->get('xpad'),
		$y+$offy+$cell->get('ypad'),-1,-1,'none',0,0);
}

1;
