#!/usr/bin/perl
package Play_Win;
use strict;
use warnings;

use if ($^O  eq 'MSWin32'), 'Win32::Sound';

our ($Mute,$Volume);

sub init
{	$Volume=-1;$Mute=0;
	return 0 unless $^O  eq 'MSWin32';
	SetVolume();
	1;
}

sub supported_formats {()}

sub GetVolume	{$Volume}
sub GetMute	{$Mute}
sub SetVolume
{	shift;
	my $oldvol=$Volume;
	my $oldm=$Mute;
	if (my $set=shift)
	{    my $v=$Volume;
	     if	($set eq 'mute')		{ $Mute=$Volume; $v=0;	}
	     elsif	($set eq 'unmute')	{ $v=$Mute; $Mute=0;}
	     elsif	($set=~m/^(\d+)%\+$/)	{ $v+=$1; }
	     elsif	($set=~m/^(\d+)%\-$/)	{ $v-=$1; }
	     elsif	($set=~m/^(\d+)%$/)	{ $v =$1;  }
	     $v=0   if $v<0;
	     $v=100 if $v>100;
	     Win32::Sound::Volume(255*$v/100);
	}
	my ($v)=Win32::Sound::Volume();
	$v=int($v*100/255);
	$Mute=0 if $v!=0;
	$Volume=$v unless $Mute;
	return unless ($oldvol!=$Volume || $oldm!=$Mute);
	::HasChanged('Vol');
}

sub SkipTo {}
sub Pause {}
sub Resume{}
sub Play {}
sub Stop {}

1;
