package GMB::Plugin::Export;
use strict;
use warnings;
use constant
{	PID	=> 'Export',
	name	=> _"Export",
};

$::Plugins{&PID}=__PACKAGE__;

my %menuentry=
(topath =>
 {	label => _"Copy to portable player",	#label of the menu entry
	code => \&Copy,				#when menu entry selected
	test => sub {my $p=$::Options{'PLUGIN_'.PID.'_path'}; $p && -d $p;},	#the menu entry is displayed if returns true
	notempty => 'IDs',			#display only if at least one song
 },
 tom3u =>
 {	label => _"export to .m3u file",
	code => \&ToM3U,
	notempty => 'IDs',
 },
);

sub init
{	updatemenu();
}
sub end
{	updatemenu('remove');
}

sub prefbox
{	my $vbox=Gtk2::VBox->new(::FALSE, 2);
	my $label1=Gtk2::Label->new(_"Export plugin");
	my $label2=Gtk2::Label->new(_"Adds menu entries to song contextual menu");
	my $entry1=::NewPrefFileEntry('PLUGIN_'.PID.'_path',_"Player mounted on :",'folder');
	my $check1=::NewPrefCheckButton('PLUGIN_'.PID.'_topath',_"Copy to mounted portable player",sub {$entry1->set_sensitive( $::Options{'PLUGIN_'.PID.'_topath'} ); updatemenu(); });
	$entry1->set_sensitive( $::Options{'PLUGIN_'.PID.'_topath'} );
	my $check2=::NewPrefCheckButton('PLUGIN_'.PID.'_tom3u',_"Export to .m3u file",sub { updatemenu(); });
	$vbox->pack_start($_,::FALSE,::FALSE,2) for $label1,$label2,$check1,$entry1,$check2;
	return $vbox;
}

sub updatemenu
{	my $removeall=$_[0];
	for my $eid (keys %menuentry)
	{	if (!$removeall && $::Options{'PLUGIN_'.PID.'_'.$eid})
		{	push @::SongCMenu,$menuentry{$eid}
				unless (grep $_==$menuentry{$eid}, @::SongCMenu);
		}
		else
		{	@::SongCMenu =grep $_!=$menuentry{$eid}, @::SongCMenu;
		}
	}
}

sub Copy
{	my $IDs=$_[0]{IDs};
	::CopyMoveFiles('Copy',$::Options{'PLUGIN_'.PID.'_path'},@{ $IDs });
}

sub ToM3U
{	my $IDs=$_[0]{IDs};
	my $file=::ChooseSaveFile(undef,_"Write filenames to ...",$::Songs[ $IDs->[0] ][::SONG_PATH],'list.m3u');
	return unless defined $file;
	open my$fh,'>',$file;
	for my $ID (@$IDs)
	 { print $fh $::Songs[$ID][::SONG_PATH].::SLASH.$::Songs[$ID][::SONG_FILE]."\n"; }
	close $fh;
}

1
