package Simple_http;
use strict;
use warnings;
use IO::Socket;

use constant { EOL => "\015\012" };
my (@Cachedurl,%Cache,$CacheSize);

sub get		#no longer used
{	my ($url,$post)=@_;
	my ($host,$port,$file)=$url=~m#^http://([^/:]+)(?::(\d+))?(.*)$#;
	return unless defined $host;
	$port=80 unless defined $port;
	my $remote = IO::Socket::INET->new
	(	Proto	=> 'tcp',
		PeerAddr=> $host,
		PeerPort=> "http($port)",
		Timeout	=> 1.5,
	);
	unless ($remote) { warn "cannot connect to server $host\n"; return undef; }
	$remote->autoflush(1);
	my $method=defined $post ? 'POST' : 'GET';
	print $remote "$method $file HTTP/1.0".EOL;
	print $remote "Host: $host:$port".EOL;
	if (defined $post)
	{ print $remote 'Content-Type: application/x-www-form-urlencoded; charset=utf-8'.EOL;
	  print $remote "Content-Length: ".length($post).EOL.EOL;
	  print $remote "$post".EOL.EOL;
	}
	else {print $remote EOL}
	my @headers;
	local $/=EOL;
	while ( <$remote> )
	{	print "0|$_" if $::debug;
		last if $_ eq EOL;
		chomp; push @headers,$_;
	}
	my $response;
	if ($headers[0]=~m#^HTTP/1\.\d+ 200 OK#)
	{	local $_;
		$response.=$_ while read $remote,$_,1024;
	}
	close $remote;
	return $response;
}

sub get_with_cb
{	my $self=bless {};
	my $error;
	if (ref $_[0]) {$self=shift; $error='Too many redirection' if 3 < $self->{redirect}++; }
	my %params=@_;
	my ($callback,$url,$post)=@params{qw/cb url post/};
	if ($params{cache} && defined $Cache{$url})
		{ warn "cached result\n" if $::debug;&$callback( @{$Cache{$url}} ); return undef; }
	my ($host,$port,$file)=$url=~m#^(?:http://)?([^/:]+)(?::(\d+))?(.*)$#;
	if (defined $host)
	{	$port=80 unless defined $port;
		$file='/' if $file eq '';
	}
	else { $error='Bad url : '.$url; }
	warn "simple_http : fetching $url\n" if $::debug;
	my $socket;
	if (!$error)
	{	$self->{sock}=$socket = IO::Socket::INET->new
		(	Proto	=> 'tcp',
			PeerAddr=> $host,
			PeerPort=> "http($port)",
			Timeout	=> 1.5,
			Blocking=> 0,
		);
		$error='cannot connect to server '.$host unless $socket;
	}
	if ($error) { warn $error."\n"; &$callback(); return undef; }

#binmode $socket,':encoding(iso-8859-1)';
	my $method=defined $post ? 'POST' : 'GET';
	print $socket "$method $file HTTP/1.0".EOL;
	print $socket "Host: $host:$port".EOL;
	if (defined $post)
	{ print $socket 'Content-Type: application/x-www-form-urlencoded; charset=utf-8'.EOL;
	  print $socket "Content-Length: ".length($post).EOL.EOL;
	  print $socket $post.EOL;
	}
	print $socket EOL;

	$socket->autoflush(1);
	my $buffer='';
	$self->{watch}=Glib::IO->add_watch(fileno($socket),['in','hup'],sub
		{	return 1 if read $socket,$buffer,1024,length($buffer);
			close $socket;
			$self->{sock}=$self->{watch}=undef;
			#warn "watch done\n";
			my $EOL=EOL;
			my ($headers,$response)=split /$EOL$EOL/o,$buffer,2;
			$headers='empty answer' unless defined $headers;
			(my$result,$headers)=split /$EOL/o,$headers,2;
			if ($::debug)
			{	warn "0|$_\n" for $result,split /$EOL/o,$headers;
			}
			$headers.=EOL;
			my %headers=($headers=~m/([^:]*): (.*?)$EOL/og);
			if ($result=~m#^HTTP/1\.\d+ 200 OK#)
			{	#warn "ok $url\n$callback\n";
				if ($params{cache} && length($response)<$::Options{Simplehttp_CacheSize})
				{	$CacheSize+=length($response);
					$Cache{$url}=[$response,$headers{'Content-Type'}];
					push @Cachedurl,$url;
					while ($CacheSize>$::Options{Simplehttp_CacheSize})
					{	my $old=pop @Cachedurl;
						$CacheSize-=length($Cache{$old}[0]);
						delete $Cache{$old};
					}
				}
				&$callback($response,$headers{'Content-Type'});
			}
			elsif ($result=~m#^HTTP/1\.\d+ 30[12]#)
			{	$params{url}=$headers{Location};
				$self->get_with_cb(%params);
			}
			else
			{	warn "Error fetching $url : $result\n";
				&$callback();
			}
			return 0;
		});
	unless ($self->{watch}) { warn "error connecting to server $host\n";&$callback(); return undef; } #not sure it can happen
	#warn "new watch $self->{watch}\n";
	return $self;
}

sub abort
{	my $self=$_[0];
	Glib::Source->remove($self->{watch}) if defined $self->{watch};
	close $self->{sock} if defined $self->{sock};
	$self->{sock}=$self->{watch}=undef;
}

sub get_lines
{	my $response=&get;
	return (defined $response)? split "\012",$response : ();
}

1;
